// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/api/servicecontrol/v2/service_controller.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fapi_2fservicecontrol_2fv2_2fservice_5fcontroller_2eproto__INCLUDED
#define GRPC_google_2fapi_2fservicecontrol_2fv2_2fservice_5fcontroller_2eproto__INCLUDED

#include "google/api/servicecontrol/v2/service_controller.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace api {
namespace servicecontrol {
namespace v2 {

// [Service Control API
// v2](https://cloud.google.com/service-infrastructure/docs/service-control/access-control)
//
// Private Preview. This feature is only available for approved services.
//
// This API provides admission control and telemetry reporting for services
// that are integrated with [Service
// Infrastructure](https://cloud.google.com/service-infrastructure).
class ServiceController final {
 public:
  static constexpr char const* service_full_name() {
    return "google.api.servicecontrol.v2.ServiceController";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Private Preview. This feature is only available for approved services.
    //
    // This method provides admission control for services that are integrated
    // with [Service
    // Infrastructure](https://cloud.google.com/service-infrastructure). It checks
    // whether an operation should be allowed based on the service configuration
    // and relevant policies. It must be called before the operation is executed.
    // For more information, see
    // [Admission
    // Control](https://cloud.google.com/service-infrastructure/docs/admission-control).
    //
    // NOTE: The admission control has an expected policy propagation delay of
    // 60s. The caller **must** not depend on the most recent policy changes.
    //
    // NOTE: The admission control has a hard limit of 1 referenced resources
    // per call. If an operation refers to more than 1 resources, the caller
    // must call the Check method multiple times.
    //
    // This method requires the `servicemanagement.services.check` permission
    // on the specified service. For more information, see
    // [Service Control API Access
    // Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).
    virtual ::grpc::Status Check(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::google::api::servicecontrol::v2::CheckResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::CheckResponse>> AsyncCheck(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::CheckResponse>>(AsyncCheckRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::CheckResponse>> PrepareAsyncCheck(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::CheckResponse>>(PrepareAsyncCheckRaw(context, request, cq));
    }
    // Private Preview. This feature is only available for approved services.
    //
    // This method provides telemetry reporting for services that are integrated
    // with [Service
    // Infrastructure](https://cloud.google.com/service-infrastructure). It
    // reports a list of operations that have occurred on a service. It must be
    // called after the operations have been executed. For more information, see
    // [Telemetry
    // Reporting](https://cloud.google.com/service-infrastructure/docs/telemetry-reporting).
    //
    // NOTE: The telemetry reporting has a hard limit of 1000 operations and 1MB
    // per Report call. It is recommended to have no more than 100 operations per
    // call.
    //
    // This method requires the `servicemanagement.services.report` permission
    // on the specified service. For more information, see
    // [Service Control API Access
    // Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).
    virtual ::grpc::Status Report(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::google::api::servicecontrol::v2::ReportResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::ReportResponse>> AsyncReport(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::ReportResponse>>(AsyncReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::ReportResponse>> PrepareAsyncReport(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::ReportResponse>>(PrepareAsyncReportRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Private Preview. This feature is only available for approved services.
      //
      // This method provides admission control for services that are integrated
      // with [Service
      // Infrastructure](https://cloud.google.com/service-infrastructure). It checks
      // whether an operation should be allowed based on the service configuration
      // and relevant policies. It must be called before the operation is executed.
      // For more information, see
      // [Admission
      // Control](https://cloud.google.com/service-infrastructure/docs/admission-control).
      //
      // NOTE: The admission control has an expected policy propagation delay of
      // 60s. The caller **must** not depend on the most recent policy changes.
      //
      // NOTE: The admission control has a hard limit of 1 referenced resources
      // per call. If an operation refers to more than 1 resources, the caller
      // must call the Check method multiple times.
      //
      // This method requires the `servicemanagement.services.check` permission
      // on the specified service. For more information, see
      // [Service Control API Access
      // Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).
      virtual void Check(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest* request, ::google::api::servicecontrol::v2::CheckResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Check(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest* request, ::google::api::servicecontrol::v2::CheckResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Private Preview. This feature is only available for approved services.
      //
      // This method provides telemetry reporting for services that are integrated
      // with [Service
      // Infrastructure](https://cloud.google.com/service-infrastructure). It
      // reports a list of operations that have occurred on a service. It must be
      // called after the operations have been executed. For more information, see
      // [Telemetry
      // Reporting](https://cloud.google.com/service-infrastructure/docs/telemetry-reporting).
      //
      // NOTE: The telemetry reporting has a hard limit of 1000 operations and 1MB
      // per Report call. It is recommended to have no more than 100 operations per
      // call.
      //
      // This method requires the `servicemanagement.services.report` permission
      // on the specified service. For more information, see
      // [Service Control API Access
      // Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).
      virtual void Report(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest* request, ::google::api::servicecontrol::v2::ReportResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Report(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest* request, ::google::api::servicecontrol::v2::ReportResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::CheckResponse>* AsyncCheckRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::CheckResponse>* PrepareAsyncCheckRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::ReportResponse>* AsyncReportRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::servicecontrol::v2::ReportResponse>* PrepareAsyncReportRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status Check(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::google::api::servicecontrol::v2::CheckResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::CheckResponse>> AsyncCheck(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::CheckResponse>>(AsyncCheckRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::CheckResponse>> PrepareAsyncCheck(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::CheckResponse>>(PrepareAsyncCheckRaw(context, request, cq));
    }
    ::grpc::Status Report(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::google::api::servicecontrol::v2::ReportResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::ReportResponse>> AsyncReport(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::ReportResponse>>(AsyncReportRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::ReportResponse>> PrepareAsyncReport(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::ReportResponse>>(PrepareAsyncReportRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void Check(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest* request, ::google::api::servicecontrol::v2::CheckResponse* response, std::function<void(::grpc::Status)>) override;
      void Check(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest* request, ::google::api::servicecontrol::v2::CheckResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Report(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest* request, ::google::api::servicecontrol::v2::ReportResponse* response, std::function<void(::grpc::Status)>) override;
      void Report(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest* request, ::google::api::servicecontrol::v2::ReportResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::CheckResponse>* AsyncCheckRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::CheckResponse>* PrepareAsyncCheckRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::CheckRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::ReportResponse>* AsyncReportRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::servicecontrol::v2::ReportResponse>* PrepareAsyncReportRaw(::grpc::ClientContext* context, const ::google::api::servicecontrol::v2::ReportRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_Check_;
    const ::grpc::internal::RpcMethod rpcmethod_Report_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Private Preview. This feature is only available for approved services.
    //
    // This method provides admission control for services that are integrated
    // with [Service
    // Infrastructure](https://cloud.google.com/service-infrastructure). It checks
    // whether an operation should be allowed based on the service configuration
    // and relevant policies. It must be called before the operation is executed.
    // For more information, see
    // [Admission
    // Control](https://cloud.google.com/service-infrastructure/docs/admission-control).
    //
    // NOTE: The admission control has an expected policy propagation delay of
    // 60s. The caller **must** not depend on the most recent policy changes.
    //
    // NOTE: The admission control has a hard limit of 1 referenced resources
    // per call. If an operation refers to more than 1 resources, the caller
    // must call the Check method multiple times.
    //
    // This method requires the `servicemanagement.services.check` permission
    // on the specified service. For more information, see
    // [Service Control API Access
    // Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).
    virtual ::grpc::Status Check(::grpc::ServerContext* context, const ::google::api::servicecontrol::v2::CheckRequest* request, ::google::api::servicecontrol::v2::CheckResponse* response);
    // Private Preview. This feature is only available for approved services.
    //
    // This method provides telemetry reporting for services that are integrated
    // with [Service
    // Infrastructure](https://cloud.google.com/service-infrastructure). It
    // reports a list of operations that have occurred on a service. It must be
    // called after the operations have been executed. For more information, see
    // [Telemetry
    // Reporting](https://cloud.google.com/service-infrastructure/docs/telemetry-reporting).
    //
    // NOTE: The telemetry reporting has a hard limit of 1000 operations and 1MB
    // per Report call. It is recommended to have no more than 100 operations per
    // call.
    //
    // This method requires the `servicemanagement.services.report` permission
    // on the specified service. For more information, see
    // [Service Control API Access
    // Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).
    virtual ::grpc::Status Report(::grpc::ServerContext* context, const ::google::api::servicecontrol::v2::ReportRequest* request, ::google::api::servicecontrol::v2::ReportResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_Check : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Check() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_Check() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Check(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::CheckRequest* /*request*/, ::google::api::servicecontrol::v2::CheckResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheck(::grpc::ServerContext* context, ::google::api::servicecontrol::v2::CheckRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicecontrol::v2::CheckResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Report : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Report() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_Report() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Report(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::ReportRequest* /*request*/, ::google::api::servicecontrol::v2::ReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReport(::grpc::ServerContext* context, ::google::api::servicecontrol::v2::ReportRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::servicecontrol::v2::ReportResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_Check<WithAsyncMethod_Report<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_Check : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Check() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicecontrol::v2::CheckRequest, ::google::api::servicecontrol::v2::CheckResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicecontrol::v2::CheckRequest* request, ::google::api::servicecontrol::v2::CheckResponse* response) { return this->Check(context, request, response); }));}
    void SetMessageAllocatorFor_Check(
        ::grpc::MessageAllocator< ::google::api::servicecontrol::v2::CheckRequest, ::google::api::servicecontrol::v2::CheckResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicecontrol::v2::CheckRequest, ::google::api::servicecontrol::v2::CheckResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Check() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Check(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::CheckRequest* /*request*/, ::google::api::servicecontrol::v2::CheckResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Check(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicecontrol::v2::CheckRequest* /*request*/, ::google::api::servicecontrol::v2::CheckResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Report : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Report() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::servicecontrol::v2::ReportRequest, ::google::api::servicecontrol::v2::ReportResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::servicecontrol::v2::ReportRequest* request, ::google::api::servicecontrol::v2::ReportResponse* response) { return this->Report(context, request, response); }));}
    void SetMessageAllocatorFor_Report(
        ::grpc::MessageAllocator< ::google::api::servicecontrol::v2::ReportRequest, ::google::api::servicecontrol::v2::ReportResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::servicecontrol::v2::ReportRequest, ::google::api::servicecontrol::v2::ReportResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Report() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Report(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::ReportRequest* /*request*/, ::google::api::servicecontrol::v2::ReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Report(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::servicecontrol::v2::ReportRequest* /*request*/, ::google::api::servicecontrol::v2::ReportResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_Check<WithCallbackMethod_Report<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_Check : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Check() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_Check() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Check(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::CheckRequest* /*request*/, ::google::api::servicecontrol::v2::CheckResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Report : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Report() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_Report() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Report(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::ReportRequest* /*request*/, ::google::api::servicecontrol::v2::ReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_Check : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Check() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_Check() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Check(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::CheckRequest* /*request*/, ::google::api::servicecontrol::v2::CheckResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheck(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Report : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Report() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_Report() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Report(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::ReportRequest* /*request*/, ::google::api::servicecontrol::v2::ReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReport(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Check : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Check() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Check(context, request, response); }));
    }
    ~WithRawCallbackMethod_Check() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Check(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::CheckRequest* /*request*/, ::google::api::servicecontrol::v2::CheckResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Check(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Report : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Report() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Report(context, request, response); }));
    }
    ~WithRawCallbackMethod_Report() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Report(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::ReportRequest* /*request*/, ::google::api::servicecontrol::v2::ReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Report(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Check : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Check() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicecontrol::v2::CheckRequest, ::google::api::servicecontrol::v2::CheckResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicecontrol::v2::CheckRequest, ::google::api::servicecontrol::v2::CheckResponse>* streamer) {
                       return this->StreamedCheck(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Check() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Check(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::CheckRequest* /*request*/, ::google::api::servicecontrol::v2::CheckResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCheck(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicecontrol::v2::CheckRequest,::google::api::servicecontrol::v2::CheckResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Report : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Report() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::servicecontrol::v2::ReportRequest, ::google::api::servicecontrol::v2::ReportResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::servicecontrol::v2::ReportRequest, ::google::api::servicecontrol::v2::ReportResponse>* streamer) {
                       return this->StreamedReport(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Report() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Report(::grpc::ServerContext* /*context*/, const ::google::api::servicecontrol::v2::ReportRequest* /*request*/, ::google::api::servicecontrol::v2::ReportResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReport(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::servicecontrol::v2::ReportRequest,::google::api::servicecontrol::v2::ReportResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_Check<WithStreamedUnaryMethod_Report<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_Check<WithStreamedUnaryMethod_Report<Service > > StreamedService;
};

}  // namespace v2
}  // namespace servicecontrol
}  // namespace api
}  // namespace google


#endif  // GRPC_google_2fapi_2fservicecontrol_2fv2_2fservice_5fcontroller_2eproto__INCLUDED
