// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/deployment_resource_pool_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_DEPLOYMENT_RESOURCE_POOL_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_DEPLOYMENT_RESOURCE_POOL_STUB_H

#include "google/cloud/completion_queue.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/aiplatform/v1/deployment_resource_pool_service.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace aiplatform_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class DeploymentResourcePoolServiceStub {
 public:
  virtual ~DeploymentResourcePoolServiceStub() = 0;

  virtual future<StatusOr<google::longrunning::Operation>>
  AsyncCreateDeploymentResourcePool(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::aiplatform::v1::CreateDeploymentResourcePoolRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> CreateDeploymentResourcePool(
      grpc::ClientContext& context, Options options,
      google::cloud::aiplatform::v1::CreateDeploymentResourcePoolRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::aiplatform::v1::DeploymentResourcePool>
  GetDeploymentResourcePool(
      grpc::ClientContext& context, Options const& options,
      google::cloud::aiplatform::v1::GetDeploymentResourcePoolRequest const&
          request) = 0;

  virtual StatusOr<
      google::cloud::aiplatform::v1::ListDeploymentResourcePoolsResponse>
  ListDeploymentResourcePools(
      grpc::ClientContext& context, Options const& options,
      google::cloud::aiplatform::v1::ListDeploymentResourcePoolsRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>>
  AsyncUpdateDeploymentResourcePool(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::aiplatform::v1::UpdateDeploymentResourcePoolRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> UpdateDeploymentResourcePool(
      grpc::ClientContext& context, Options options,
      google::cloud::aiplatform::v1::UpdateDeploymentResourcePoolRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>>
  AsyncDeleteDeploymentResourcePool(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::aiplatform::v1::DeleteDeploymentResourcePoolRequest const&
          request) = 0;

  virtual StatusOr<google::longrunning::Operation> DeleteDeploymentResourcePool(
      grpc::ClientContext& context, Options options,
      google::cloud::aiplatform::v1::DeleteDeploymentResourcePoolRequest const&
          request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) = 0;

  virtual future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) = 0;
};

class DefaultDeploymentResourcePoolServiceStub
    : public DeploymentResourcePoolServiceStub {
 public:
  DefaultDeploymentResourcePoolServiceStub(
      std::unique_ptr<google::cloud::aiplatform::v1::
                          DeploymentResourcePoolService::StubInterface>
          grpc_stub,
      std::unique_ptr<google::longrunning::Operations::StubInterface>
          operations)
      : grpc_stub_(std::move(grpc_stub)), operations_(std::move(operations)) {}

  future<StatusOr<google::longrunning::Operation>>
  AsyncCreateDeploymentResourcePool(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::aiplatform::v1::CreateDeploymentResourcePoolRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> CreateDeploymentResourcePool(
      grpc::ClientContext& context, Options options,
      google::cloud::aiplatform::v1::CreateDeploymentResourcePoolRequest const&
          request) override;

  StatusOr<google::cloud::aiplatform::v1::DeploymentResourcePool>
  GetDeploymentResourcePool(
      grpc::ClientContext& context, Options const& options,
      google::cloud::aiplatform::v1::GetDeploymentResourcePoolRequest const&
          request) override;

  StatusOr<google::cloud::aiplatform::v1::ListDeploymentResourcePoolsResponse>
  ListDeploymentResourcePools(
      grpc::ClientContext& context, Options const& options,
      google::cloud::aiplatform::v1::ListDeploymentResourcePoolsRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncUpdateDeploymentResourcePool(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::aiplatform::v1::UpdateDeploymentResourcePoolRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> UpdateDeploymentResourcePool(
      grpc::ClientContext& context, Options options,
      google::cloud::aiplatform::v1::UpdateDeploymentResourcePoolRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncDeleteDeploymentResourcePool(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::aiplatform::v1::DeleteDeploymentResourcePoolRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> DeleteDeploymentResourcePool(
      grpc::ClientContext& context, Options options,
      google::cloud::aiplatform::v1::DeleteDeploymentResourcePoolRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::unique_ptr<google::cloud::aiplatform::v1::DeploymentResourcePoolService::
                      StubInterface>
      grpc_stub_;
  std::unique_ptr<google::longrunning::Operations::StubInterface> operations_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_DEPLOYMENT_RESOURCE_POOL_STUB_H
