// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/completion_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_COMPLETION_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_COMPLETION_CONNECTION_IMPL_H

#include "google/cloud/discoveryengine/v1/completion_connection.h"
#include "google/cloud/discoveryengine/v1/completion_connection_idempotency_policy.h"
#include "google/cloud/discoveryengine/v1/completion_options.h"
#include "google/cloud/discoveryengine/v1/internal/completion_retry_traits.h"
#include "google/cloud/discoveryengine/v1/internal/completion_stub.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace discoveryengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class CompletionServiceConnectionImpl
    : public discoveryengine_v1::CompletionServiceConnection {
 public:
  ~CompletionServiceConnectionImpl() override = default;

  CompletionServiceConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<discoveryengine_v1_internal::CompletionServiceStub> stub,
      Options options);

  Options options() override { return options_; }

  StatusOr<google::cloud::discoveryengine::v1::CompleteQueryResponse>
  CompleteQuery(google::cloud::discoveryengine::v1::CompleteQueryRequest const&
                    request) override;

  future<StatusOr<google::cloud::discoveryengine::v1::
                      ImportSuggestionDenyListEntriesResponse>>
  ImportSuggestionDenyListEntries(
      google::cloud::discoveryengine::v1::
          ImportSuggestionDenyListEntriesRequest const& request) override;

  StatusOr<google::longrunning::Operation> ImportSuggestionDenyListEntries(
      NoAwaitTag,
      google::cloud::discoveryengine::v1::
          ImportSuggestionDenyListEntriesRequest const& request) override;

  future<StatusOr<google::cloud::discoveryengine::v1::
                      ImportSuggestionDenyListEntriesResponse>>
  ImportSuggestionDenyListEntries(
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::discoveryengine::v1::
                      PurgeSuggestionDenyListEntriesResponse>>
  PurgeSuggestionDenyListEntries(
      google::cloud::discoveryengine::v1::
          PurgeSuggestionDenyListEntriesRequest const& request) override;

  StatusOr<google::longrunning::Operation> PurgeSuggestionDenyListEntries(
      NoAwaitTag,
      google::cloud::discoveryengine::v1::
          PurgeSuggestionDenyListEntriesRequest const& request) override;

  future<StatusOr<google::cloud::discoveryengine::v1::
                      PurgeSuggestionDenyListEntriesResponse>>
  PurgeSuggestionDenyListEntries(
      google::longrunning::Operation const& operation) override;

  future<StatusOr<
      google::cloud::discoveryengine::v1::ImportCompletionSuggestionsResponse>>
  ImportCompletionSuggestions(
      google::cloud::discoveryengine::v1::
          ImportCompletionSuggestionsRequest const& request) override;

  StatusOr<google::longrunning::Operation> ImportCompletionSuggestions(
      NoAwaitTag,
      google::cloud::discoveryengine::v1::
          ImportCompletionSuggestionsRequest const& request) override;

  future<StatusOr<
      google::cloud::discoveryengine::v1::ImportCompletionSuggestionsResponse>>
  ImportCompletionSuggestions(
      google::longrunning::Operation const& operation) override;

  future<StatusOr<
      google::cloud::discoveryengine::v1::PurgeCompletionSuggestionsResponse>>
  PurgeCompletionSuggestions(
      google::cloud::discoveryengine::v1::
          PurgeCompletionSuggestionsRequest const& request) override;

  StatusOr<google::longrunning::Operation> PurgeCompletionSuggestions(
      NoAwaitTag,
      google::cloud::discoveryengine::v1::
          PurgeCompletionSuggestionsRequest const& request) override;

  future<StatusOr<
      google::cloud::discoveryengine::v1::PurgeCompletionSuggestionsResponse>>
  PurgeCompletionSuggestions(
      google::longrunning::Operation const& operation) override;

 private:
  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<discoveryengine_v1_internal::CompletionServiceStub> stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_COMPLETION_CONNECTION_IMPL_H
