// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/orgpolicy/v2/orgpolicy.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2forgpolicy_2fv2_2forgpolicy_2eproto__INCLUDED
#define GRPC_google_2fcloud_2forgpolicy_2fv2_2forgpolicy_2eproto__INCLUDED

#include "google/cloud/orgpolicy/v2/orgpolicy.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace orgpolicy {
namespace v2 {

// An interface for managing organization policies.
//
// The Organization Policy Service provides a simple mechanism for
// organizations to restrict the allowed configurations across their entire
// resource hierarchy.
//
// You can use a policy to configure restrictions on resources. For
// example, you can enforce a policy that restricts which Google
// Cloud APIs can be activated in a certain part of your resource
// hierarchy, or prevents serial port access to VM instances in a
// particular folder.
//
// Policies are inherited down through the resource hierarchy. A policy
// applied to a parent resource automatically applies to all its child resources
// unless overridden with a policy lower in the hierarchy.
//
// A constraint defines an aspect of a resource's configuration that can be
// controlled by an organization's policy administrator. Policies are a
// collection of constraints that defines their allowable configuration on a
// particular resource and its child resources.
class OrgPolicy final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.orgpolicy.v2.OrgPolicy";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists constraints that could be applied on the specified resource.
    virtual ::grpc::Status ListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>> AsyncListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>>(AsyncListConstraintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>> PrepareAsyncListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>>(PrepareAsyncListConstraintsRaw(context, request, cq));
    }
    // Retrieves all of the policies that exist on a particular resource.
    virtual ::grpc::Status ListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>> AsyncListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>>(AsyncListPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>> PrepareAsyncListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>>(PrepareAsyncListPoliciesRaw(context, request, cq));
    }
    // Gets a policy on a resource.
    //
    // If no policy is set on the resource, `NOT_FOUND` is returned. The
    // `etag` value can be used with `UpdatePolicy()` to update a
    // policy during read-modify-write.
    virtual ::grpc::Status GetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> AsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(AsyncGetPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncGetPolicyRaw(context, request, cq));
    }
    // Gets the effective policy on a resource. This is the result of merging
    // policies in the resource hierarchy and evaluating conditions. The
    // returned policy will not have an `etag` or `condition` set because it is
    // an evaluated policy across multiple resources.
    // Subtrees of Resource Manager resource hierarchy with 'under:' prefix will
    // not be expanded.
    virtual ::grpc::Status GetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> AsyncGetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(AsyncGetEffectivePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncGetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncGetEffectivePolicyRaw(context, request, cq));
    }
    // Creates a policy.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint does not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ALREADY_EXISTS` if the
    // policy already exists on the given Google Cloud resource.
    virtual ::grpc::Status CreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> AsyncCreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(AsyncCreatePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncCreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncCreatePolicyRaw(context, request, cq));
    }
    // Updates a policy.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint or the policy do not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ABORTED` if the etag
    // supplied in the request does not match the persisted etag of the policy
    //
    // Note: the supplied policy will perform a full overwrite of all
    // fields.
    virtual ::grpc::Status UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> AsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(AsyncUpdatePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncUpdatePolicyRaw(context, request, cq));
    }
    // Deletes a policy.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint or organization policy does not exist.
    virtual ::grpc::Status DeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeletePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeletePolicyRaw(context, request, cq));
    }
    // Creates a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // organization does not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ALREADY_EXISTS` if the
    // constraint already exists on the given organization.
    virtual ::grpc::Status CreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>> AsyncCreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>>(AsyncCreateCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>> PrepareAsyncCreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>>(PrepareAsyncCreateCustomConstraintRaw(context, request, cq));
    }
    // Updates a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint does not exist.
    //
    // Note: the supplied policy will perform a full overwrite of all
    // fields.
    virtual ::grpc::Status UpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>> AsyncUpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>>(AsyncUpdateCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>> PrepareAsyncUpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>>(PrepareAsyncUpdateCustomConstraintRaw(context, request, cq));
    }
    // Gets a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // custom constraint does not exist.
    virtual ::grpc::Status GetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>> AsyncGetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>>(AsyncGetCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>> PrepareAsyncGetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>>(PrepareAsyncGetCustomConstraintRaw(context, request, cq));
    }
    // Retrieves all of the custom constraints that exist on a particular
    // organization resource.
    virtual ::grpc::Status ListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>> AsyncListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>>(AsyncListCustomConstraintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>> PrepareAsyncListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>>(PrepareAsyncListCustomConstraintsRaw(context, request, cq));
    }
    // Deletes a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint does not exist.
    virtual ::grpc::Status DeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteCustomConstraintRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists constraints that could be applied on the specified resource.
      virtual void ListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves all of the policies that exist on a particular resource.
      virtual void ListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a policy on a resource.
      //
      // If no policy is set on the resource, `NOT_FOUND` is returned. The
      // `etag` value can be used with `UpdatePolicy()` to update a
      // policy during read-modify-write.
      virtual void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the effective policy on a resource. This is the result of merging
      // policies in the resource hierarchy and evaluating conditions. The
      // returned policy will not have an `etag` or `condition` set because it is
      // an evaluated policy across multiple resources.
      // Subtrees of Resource Manager resource hierarchy with 'under:' prefix will
      // not be expanded.
      virtual void GetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a policy.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // constraint does not exist.
      // Returns a `google.rpc.Status` with `google.rpc.Code.ALREADY_EXISTS` if the
      // policy already exists on the given Google Cloud resource.
      virtual void CreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a policy.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // constraint or the policy do not exist.
      // Returns a `google.rpc.Status` with `google.rpc.Code.ABORTED` if the etag
      // supplied in the request does not match the persisted etag of the policy
      //
      // Note: the supplied policy will perform a full overwrite of all
      // fields.
      virtual void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a policy.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // constraint or organization policy does not exist.
      virtual void DeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a custom constraint.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // organization does not exist.
      // Returns a `google.rpc.Status` with `google.rpc.Code.ALREADY_EXISTS` if the
      // constraint already exists on the given organization.
      virtual void CreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a custom constraint.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // constraint does not exist.
      //
      // Note: the supplied policy will perform a full overwrite of all
      // fields.
      virtual void UpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a custom constraint.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // custom constraint does not exist.
      virtual void GetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves all of the custom constraints that exist on a particular
      // organization resource.
      virtual void ListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a custom constraint.
      //
      // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
      // constraint does not exist.
      virtual void DeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>* AsyncListConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>* PrepareAsyncListConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>* AsyncListPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>* PrepareAsyncListPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* AsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* AsyncGetEffectivePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncGetEffectivePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* AsyncCreatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncCreatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* AsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeletePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeletePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>* AsyncCreateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>* PrepareAsyncCreateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>* AsyncUpdateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>* PrepareAsyncUpdateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>* AsyncGetCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::CustomConstraint>* PrepareAsyncGetCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* AsyncListCustomConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* PrepareAsyncListCustomConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>> AsyncListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>>(AsyncListConstraintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>> PrepareAsyncListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>>(PrepareAsyncListConstraintsRaw(context, request, cq));
    }
    ::grpc::Status ListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>> AsyncListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>>(AsyncListPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>> PrepareAsyncListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>>(PrepareAsyncListPoliciesRaw(context, request, cq));
    }
    ::grpc::Status GetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> AsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(AsyncGetPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncGetPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> AsyncGetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(AsyncGetEffectivePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncGetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncGetEffectivePolicyRaw(context, request, cq));
    }
    ::grpc::Status CreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> AsyncCreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(AsyncCreatePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncCreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncCreatePolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::google::cloud::orgpolicy::v2::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> AsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(AsyncUpdatePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>> PrepareAsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>>(PrepareAsyncUpdatePolicyRaw(context, request, cq));
    }
    ::grpc::Status DeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeletePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeletePolicyRaw(context, request, cq));
    }
    ::grpc::Status CreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>> AsyncCreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>>(AsyncCreateCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>> PrepareAsyncCreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>>(PrepareAsyncCreateCustomConstraintRaw(context, request, cq));
    }
    ::grpc::Status UpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>> AsyncUpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>>(AsyncUpdateCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>> PrepareAsyncUpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>>(PrepareAsyncUpdateCustomConstraintRaw(context, request, cq));
    }
    ::grpc::Status GetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>> AsyncGetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>>(AsyncGetCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>> PrepareAsyncGetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>>(PrepareAsyncGetCustomConstraintRaw(context, request, cq));
    }
    ::grpc::Status ListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>> AsyncListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>>(AsyncListCustomConstraintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>> PrepareAsyncListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>>(PrepareAsyncListCustomConstraintsRaw(context, request, cq));
    }
    ::grpc::Status DeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteCustomConstraintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteCustomConstraintRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPolicies(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetEffectivePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) override;
      void CreatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, std::function<void(::grpc::Status)>) override;
      void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeletePolicy(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, std::function<void(::grpc::Status)>) override;
      void CreateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, std::function<void(::grpc::Status)>) override;
      void UpdateCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, std::function<void(::grpc::Status)>) override;
      void GetCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCustomConstraints(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteCustomConstraint(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>* AsyncListConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>* PrepareAsyncListConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>* AsyncListPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>* PrepareAsyncListPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* AsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* AsyncGetEffectivePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncGetEffectivePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* AsyncCreatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncCreatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* AsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::Policy>* PrepareAsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeletePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeletePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>* AsyncCreateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>* PrepareAsyncCreateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>* AsyncUpdateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>* PrepareAsyncUpdateCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>* AsyncGetCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::CustomConstraint>* PrepareAsyncGetCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* AsyncListCustomConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* PrepareAsyncListCustomConstraintsRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteCustomConstraintRaw(::grpc::ClientContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListConstraints_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEffectivePolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCustomConstraint_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCustomConstraint_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCustomConstraint_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCustomConstraints_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCustomConstraint_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists constraints that could be applied on the specified resource.
    virtual ::grpc::Status ListConstraints(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response);
    // Retrieves all of the policies that exist on a particular resource.
    virtual ::grpc::Status ListPolicies(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response);
    // Gets a policy on a resource.
    //
    // If no policy is set on the resource, `NOT_FOUND` is returned. The
    // `etag` value can be used with `UpdatePolicy()` to update a
    // policy during read-modify-write.
    virtual ::grpc::Status GetPolicy(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response);
    // Gets the effective policy on a resource. This is the result of merging
    // policies in the resource hierarchy and evaluating conditions. The
    // returned policy will not have an `etag` or `condition` set because it is
    // an evaluated policy across multiple resources.
    // Subtrees of Resource Manager resource hierarchy with 'under:' prefix will
    // not be expanded.
    virtual ::grpc::Status GetEffectivePolicy(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response);
    // Creates a policy.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint does not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ALREADY_EXISTS` if the
    // policy already exists on the given Google Cloud resource.
    virtual ::grpc::Status CreatePolicy(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response);
    // Updates a policy.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint or the policy do not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ABORTED` if the etag
    // supplied in the request does not match the persisted etag of the policy
    //
    // Note: the supplied policy will perform a full overwrite of all
    // fields.
    virtual ::grpc::Status UpdatePolicy(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response);
    // Deletes a policy.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint or organization policy does not exist.
    virtual ::grpc::Status DeletePolicy(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* request, ::google::protobuf::Empty* response);
    // Creates a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // organization does not exist.
    // Returns a `google.rpc.Status` with `google.rpc.Code.ALREADY_EXISTS` if the
    // constraint already exists on the given organization.
    virtual ::grpc::Status CreateCustomConstraint(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response);
    // Updates a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint does not exist.
    //
    // Note: the supplied policy will perform a full overwrite of all
    // fields.
    virtual ::grpc::Status UpdateCustomConstraint(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response);
    // Gets a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // custom constraint does not exist.
    virtual ::grpc::Status GetCustomConstraint(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response);
    // Retrieves all of the custom constraints that exist on a particular
    // organization resource.
    virtual ::grpc::Status ListCustomConstraints(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response);
    // Deletes a custom constraint.
    //
    // Returns a `google.rpc.Status` with `google.rpc.Code.NOT_FOUND` if the
    // constraint does not exist.
    virtual ::grpc::Status DeleteCustomConstraint(::grpc::ServerContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListConstraints() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConstraints(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::ListConstraintsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::ListConstraintsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPolicies() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicies(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::ListPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::ListPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPolicy() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicy(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::GetPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEffectivePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEffectivePolicy() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetEffectivePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEffectivePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEffectivePolicy(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePolicy() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicy(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::CreatePolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicy(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePolicy() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeletePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicy(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::DeletePolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCustomConstraint() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomConstraint(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::CustomConstraint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCustomConstraint() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomConstraint(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::CustomConstraint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCustomConstraint() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomConstraint(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::CustomConstraint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCustomConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCustomConstraints() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListCustomConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomConstraints(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCustomConstraint() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeleteCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomConstraint(::grpc::ServerContext* context, ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListConstraints<WithAsyncMethod_ListPolicies<WithAsyncMethod_GetPolicy<WithAsyncMethod_GetEffectivePolicy<WithAsyncMethod_CreatePolicy<WithAsyncMethod_UpdatePolicy<WithAsyncMethod_DeletePolicy<WithAsyncMethod_CreateCustomConstraint<WithAsyncMethod_UpdateCustomConstraint<WithAsyncMethod_GetCustomConstraint<WithAsyncMethod_ListCustomConstraints<WithAsyncMethod_DeleteCustomConstraint<Service > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListConstraints() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::ListConstraintsRequest, ::google::cloud::orgpolicy::v2::ListConstraintsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* response) { return this->ListConstraints(context, request, response); }));}
    void SetMessageAllocatorFor_ListConstraints(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::ListConstraintsRequest, ::google::cloud::orgpolicy::v2::ListConstraintsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::ListConstraintsRequest, ::google::cloud::orgpolicy::v2::ListConstraintsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConstraints(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPolicies() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::ListPoliciesRequest, ::google::cloud::orgpolicy::v2::ListPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* request, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* response) { return this->ListPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListPolicies(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::ListPoliciesRequest, ::google::cloud::orgpolicy::v2::ListPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::ListPoliciesRequest, ::google::cloud::orgpolicy::v2::ListPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPolicy() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::GetPolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response) { return this->GetPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetPolicy(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::GetPolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::GetPolicyRequest, ::google::cloud::orgpolicy::v2::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEffectivePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEffectivePolicy() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response) { return this->GetEffectivePolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetEffectivePolicy(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEffectivePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEffectivePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEffectivePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePolicy() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::CreatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response) { return this->CreatePolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePolicy(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::CreatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::CreatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::UpdatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* request, ::google::cloud::orgpolicy::v2::Policy* response) { return this->UpdatePolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePolicy(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::UpdatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::UpdatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePolicy() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::DeletePolicyRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* request, ::google::protobuf::Empty* response) { return this->DeletePolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePolicy(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::DeletePolicyRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::DeletePolicyRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCustomConstraint() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) { return this->CreateCustomConstraint(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCustomConstraint(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCustomConstraint() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) { return this->UpdateCustomConstraint(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCustomConstraint(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCustomConstraint() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* request, ::google::cloud::orgpolicy::v2::CustomConstraint* response) { return this->GetCustomConstraint(context, request, response); }));}
    void SetMessageAllocatorFor_GetCustomConstraint(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCustomConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCustomConstraints() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* request, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* response) { return this->ListCustomConstraints(context, request, response); }));}
    void SetMessageAllocatorFor_ListCustomConstraints(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCustomConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomConstraints(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCustomConstraint() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* request, ::google::protobuf::Empty* response) { return this->DeleteCustomConstraint(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCustomConstraint(
        ::grpc::MessageAllocator< ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListConstraints<WithCallbackMethod_ListPolicies<WithCallbackMethod_GetPolicy<WithCallbackMethod_GetEffectivePolicy<WithCallbackMethod_CreatePolicy<WithCallbackMethod_UpdatePolicy<WithCallbackMethod_DeletePolicy<WithCallbackMethod_CreateCustomConstraint<WithCallbackMethod_UpdateCustomConstraint<WithCallbackMethod_GetCustomConstraint<WithCallbackMethod_ListCustomConstraints<WithCallbackMethod_DeleteCustomConstraint<Service > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListConstraints() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPolicies() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPolicy() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEffectivePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEffectivePolicy() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetEffectivePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEffectivePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePolicy() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePolicy() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeletePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCustomConstraint() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCustomConstraint() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCustomConstraint() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCustomConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCustomConstraints() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListCustomConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCustomConstraint() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeleteCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListConstraints() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConstraints(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPolicies() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPolicy() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEffectivePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEffectivePolicy() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetEffectivePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEffectivePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEffectivePolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePolicy() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePolicy() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeletePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCustomConstraint() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomConstraint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCustomConstraint() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomConstraint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCustomConstraint() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomConstraint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCustomConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCustomConstraints() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListCustomConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomConstraints(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCustomConstraint() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeleteCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomConstraint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListConstraints() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListConstraints(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConstraints(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPolicies() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPolicy() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEffectivePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEffectivePolicy() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEffectivePolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEffectivePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEffectivePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEffectivePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePolicy() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePolicy() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCustomConstraint() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCustomConstraint(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCustomConstraint() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCustomConstraint(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCustomConstraint() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCustomConstraint(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCustomConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCustomConstraints() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCustomConstraints(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCustomConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomConstraints(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCustomConstraint() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCustomConstraint(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomConstraint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListConstraints() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::ListConstraintsRequest, ::google::cloud::orgpolicy::v2::ListConstraintsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::ListConstraintsRequest, ::google::cloud::orgpolicy::v2::ListConstraintsResponse>* streamer) {
                       return this->StreamedListConstraints(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListConstraints(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::ListConstraintsRequest,::google::cloud::orgpolicy::v2::ListConstraintsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPolicies() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::ListPoliciesRequest, ::google::cloud::orgpolicy::v2::ListPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::ListPoliciesRequest, ::google::cloud::orgpolicy::v2::ListPoliciesResponse>* streamer) {
                       return this->StreamedListPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListPoliciesRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::ListPoliciesRequest,::google::cloud::orgpolicy::v2::ListPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPolicy() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::GetPolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::GetPolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* streamer) {
                       return this->StreamedGetPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetPolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::GetPolicyRequest,::google::cloud::orgpolicy::v2::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEffectivePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEffectivePolicy() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* streamer) {
                       return this->StreamedGetEffectivePolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEffectivePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEffectivePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEffectivePolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::GetEffectivePolicyRequest,::google::cloud::orgpolicy::v2::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePolicy() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::CreatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::CreatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* streamer) {
                       return this->StreamedCreatePolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::CreatePolicyRequest,::google::cloud::orgpolicy::v2::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::UpdatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::UpdatePolicyRequest, ::google::cloud::orgpolicy::v2::Policy>* streamer) {
                       return this->StreamedUpdatePolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdatePolicyRequest* /*request*/, ::google::cloud::orgpolicy::v2::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::UpdatePolicyRequest,::google::cloud::orgpolicy::v2::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePolicy() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::DeletePolicyRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::DeletePolicyRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeletePolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeletePolicyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::DeletePolicyRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCustomConstraint() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>* streamer) {
                       return this->StreamedCreateCustomConstraint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCustomConstraint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::CreateCustomConstraintRequest,::google::cloud::orgpolicy::v2::CustomConstraint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCustomConstraint() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>* streamer) {
                       return this->StreamedUpdateCustomConstraint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCustomConstraint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::UpdateCustomConstraintRequest,::google::cloud::orgpolicy::v2::CustomConstraint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCustomConstraint() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest, ::google::cloud::orgpolicy::v2::CustomConstraint>* streamer) {
                       return this->StreamedGetCustomConstraint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest* /*request*/, ::google::cloud::orgpolicy::v2::CustomConstraint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCustomConstraint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::GetCustomConstraintRequest,::google::cloud::orgpolicy::v2::CustomConstraint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCustomConstraints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCustomConstraints() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* streamer) {
                       return this->StreamedListCustomConstraints(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCustomConstraints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCustomConstraints(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest* /*request*/, ::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCustomConstraints(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::ListCustomConstraintsRequest,::google::cloud::orgpolicy::v2::ListCustomConstraintsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCustomConstraint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCustomConstraint() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteCustomConstraint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCustomConstraint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCustomConstraint(::grpc::ServerContext* /*context*/, const ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCustomConstraint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::orgpolicy::v2::DeleteCustomConstraintRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListConstraints<WithStreamedUnaryMethod_ListPolicies<WithStreamedUnaryMethod_GetPolicy<WithStreamedUnaryMethod_GetEffectivePolicy<WithStreamedUnaryMethod_CreatePolicy<WithStreamedUnaryMethod_UpdatePolicy<WithStreamedUnaryMethod_DeletePolicy<WithStreamedUnaryMethod_CreateCustomConstraint<WithStreamedUnaryMethod_UpdateCustomConstraint<WithStreamedUnaryMethod_GetCustomConstraint<WithStreamedUnaryMethod_ListCustomConstraints<WithStreamedUnaryMethod_DeleteCustomConstraint<Service > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListConstraints<WithStreamedUnaryMethod_ListPolicies<WithStreamedUnaryMethod_GetPolicy<WithStreamedUnaryMethod_GetEffectivePolicy<WithStreamedUnaryMethod_CreatePolicy<WithStreamedUnaryMethod_UpdatePolicy<WithStreamedUnaryMethod_DeletePolicy<WithStreamedUnaryMethod_CreateCustomConstraint<WithStreamedUnaryMethod_UpdateCustomConstraint<WithStreamedUnaryMethod_GetCustomConstraint<WithStreamedUnaryMethod_ListCustomConstraints<WithStreamedUnaryMethod_DeleteCustomConstraint<Service > > > > > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace orgpolicy
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2forgpolicy_2fv2_2forgpolicy_2eproto__INCLUDED
