// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/retail/v2/model_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_MOCKS_MOCK_MODEL_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_MOCKS_MOCK_MODEL_CONNECTION_H

#include "google/cloud/retail/v2/model_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace retail_v2_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `ModelServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `ModelServiceClient`. To do so,
 * construct an object of type `ModelServiceClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockModelServiceConnection : public retail_v2::ModelServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  /// To disambiguate calls, use:
  ///
  /// @code
  /// using ::testing::_;
  /// using ::testing::Matcher;
  /// EXPECT_CALL(*mock,
  /// CreateModel(Matcher<google::cloud::retail::v2::CreateModelRequest
  /// const&>(_)))
  /// @endcode
  MOCK_METHOD(future<StatusOr<google::cloud::retail::v2::Model>>, CreateModel,
              (google::cloud::retail::v2::CreateModelRequest const& request),
              (override));

  /// To disambiguate calls, use:
  ///
  /// @code
  /// using ::testing::_;
  /// EXPECT_CALL(*mock, CreateModel(_, _))
  /// @endcode
  MOCK_METHOD(StatusOr<google::longrunning::Operation>, CreateModel,
              (NoAwaitTag,
               google::cloud::retail::v2::CreateModelRequest const& request),
              (override));

  /// To disambiguate calls, use:
  ///
  /// @code
  /// using ::testing::_;
  /// using ::testing::Matcher;
  /// EXPECT_CALL(*mock, CreateModel(Matcher<google::longrunning::Operation
  /// const&>(_)))
  /// @endcode
  MOCK_METHOD(future<StatusOr<google::cloud::retail::v2::Model>>, CreateModel,
              (google::longrunning::Operation const& operation), (override));

  MOCK_METHOD(StatusOr<google::cloud::retail::v2::Model>, GetModel,
              (google::cloud::retail::v2::GetModelRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::retail::v2::Model>, PauseModel,
              (google::cloud::retail::v2::PauseModelRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::retail::v2::Model>, ResumeModel,
              (google::cloud::retail::v2::ResumeModelRequest const& request),
              (override));

  MOCK_METHOD(Status, DeleteModel,
              (google::cloud::retail::v2::DeleteModelRequest const& request),
              (override));

  MOCK_METHOD((StreamRange<google::cloud::retail::v2::Model>), ListModels,
              (google::cloud::retail::v2::ListModelsRequest request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::retail::v2::Model>, UpdateModel,
              (google::cloud::retail::v2::UpdateModelRequest const& request),
              (override));

  /// To disambiguate calls, use:
  ///
  /// @code
  /// using ::testing::_;
  /// using ::testing::Matcher;
  /// EXPECT_CALL(*mock,
  /// TuneModel(Matcher<google::cloud::retail::v2::TuneModelRequest const&>(_)))
  /// @endcode
  MOCK_METHOD(future<StatusOr<google::cloud::retail::v2::TuneModelResponse>>,
              TuneModel,
              (google::cloud::retail::v2::TuneModelRequest const& request),
              (override));

  /// To disambiguate calls, use:
  ///
  /// @code
  /// using ::testing::_;
  /// EXPECT_CALL(*mock, TuneModel(_, _))
  /// @endcode
  MOCK_METHOD(StatusOr<google::longrunning::Operation>, TuneModel,
              (NoAwaitTag,
               google::cloud::retail::v2::TuneModelRequest const& request),
              (override));

  /// To disambiguate calls, use:
  ///
  /// @code
  /// using ::testing::_;
  /// using ::testing::Matcher;
  /// EXPECT_CALL(*mock, TuneModel(Matcher<google::longrunning::Operation
  /// const&>(_)))
  /// @endcode
  MOCK_METHOD(future<StatusOr<google::cloud::retail::v2::TuneModelResponse>>,
              TuneModel, (google::longrunning::Operation const& operation),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace retail_v2_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_MOCKS_MOCK_MODEL_CONNECTION_H
