// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/retail/v2/model_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_MODEL_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_MODEL_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/retail/v2/model_service.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace retail_v2 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class ModelServiceConnectionIdempotencyPolicy {
 public:
  virtual ~ModelServiceConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<ModelServiceConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency CreateModel(
      google::cloud::retail::v2::CreateModelRequest const& request);

  virtual google::cloud::Idempotency GetModel(
      google::cloud::retail::v2::GetModelRequest const& request);

  virtual google::cloud::Idempotency PauseModel(
      google::cloud::retail::v2::PauseModelRequest const& request);

  virtual google::cloud::Idempotency ResumeModel(
      google::cloud::retail::v2::ResumeModelRequest const& request);

  virtual google::cloud::Idempotency DeleteModel(
      google::cloud::retail::v2::DeleteModelRequest const& request);

  virtual google::cloud::Idempotency ListModels(
      google::cloud::retail::v2::ListModelsRequest request);

  virtual google::cloud::Idempotency UpdateModel(
      google::cloud::retail::v2::UpdateModelRequest const& request);

  virtual google::cloud::Idempotency TuneModel(
      google::cloud::retail::v2::TuneModelRequest const& request);
};

std::unique_ptr<ModelServiceConnectionIdempotencyPolicy>
MakeDefaultModelServiceConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace retail_v2
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_MODEL_CONNECTION_IDEMPOTENCY_POLICY_H
