// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/deploy/v1/cloud_deploy.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdeploy_2fv1_2fcloud_5fdeploy_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdeploy_2fv1_2fcloud_5fdeploy_2eproto__INCLUDED

#include "google/cloud/deploy/v1/cloud_deploy.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace deploy {
namespace v1 {

// CloudDeploy service creates and manages Continuous Delivery operations
// on Google Cloud Platform via Skaffold (https://skaffold.dev).
class CloudDeploy final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.deploy.v1.CloudDeploy";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists DeliveryPipelines in a given project and location.
    virtual ::grpc::Status ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> AsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(AsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> PrepareAsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(PrepareAsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    // Gets details of a single DeliveryPipeline.
    virtual ::grpc::Status GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::google::cloud::deploy::v1::DeliveryPipeline* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>> AsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>>(AsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>> PrepareAsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>>(PrepareAsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    // Creates a new DeliveryPipeline in a given project and location.
    virtual ::grpc::Status CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    // Updates the parameters of a single DeliveryPipeline.
    virtual ::grpc::Status UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    // Deletes a single DeliveryPipeline.
    virtual ::grpc::Status DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    // Lists Targets in a given project and location.
    virtual ::grpc::Status ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::google::cloud::deploy::v1::ListTargetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>> AsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>>(AsyncListTargetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>> PrepareAsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>>(PrepareAsyncListTargetsRaw(context, request, cq));
    }
    // Creates a `Rollout` to roll back the specified target.
    virtual ::grpc::Status RollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::google::cloud::deploy::v1::RollbackTargetResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RollbackTargetResponse>> AsyncRollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RollbackTargetResponse>>(AsyncRollbackTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RollbackTargetResponse>> PrepareAsyncRollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RollbackTargetResponse>>(PrepareAsyncRollbackTargetRaw(context, request, cq));
    }
    // Gets details of a single Target.
    virtual ::grpc::Status GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::google::cloud::deploy::v1::Target* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>> AsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>>(AsyncGetTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>> PrepareAsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>>(PrepareAsyncGetTargetRaw(context, request, cq));
    }
    // Creates a new Target in a given project and location.
    virtual ::grpc::Status CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateTargetRaw(context, request, cq));
    }
    // Updates the parameters of a single Target.
    virtual ::grpc::Status UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateTargetRaw(context, request, cq));
    }
    // Deletes a single Target.
    virtual ::grpc::Status DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteTargetRaw(context, request, cq));
    }
    // Lists CustomTargetTypes in a given project and location.
    virtual ::grpc::Status ListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>> AsyncListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>>(AsyncListCustomTargetTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>> PrepareAsyncListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>>(PrepareAsyncListCustomTargetTypesRaw(context, request, cq));
    }
    // Gets details of a single CustomTargetType.
    virtual ::grpc::Status GetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::google::cloud::deploy::v1::CustomTargetType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CustomTargetType>> AsyncGetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CustomTargetType>>(AsyncGetCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CustomTargetType>> PrepareAsyncGetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CustomTargetType>>(PrepareAsyncGetCustomTargetTypeRaw(context, request, cq));
    }
    // Creates a new CustomTargetType in a given project and location.
    virtual ::grpc::Status CreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateCustomTargetTypeRaw(context, request, cq));
    }
    // Updates a single CustomTargetType.
    virtual ::grpc::Status UpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateCustomTargetTypeRaw(context, request, cq));
    }
    // Deletes a single CustomTargetType.
    virtual ::grpc::Status DeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteCustomTargetTypeRaw(context, request, cq));
    }
    // Lists Releases in a given project and location.
    virtual ::grpc::Status ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::google::cloud::deploy::v1::ListReleasesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>> AsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>>(AsyncListReleasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>> PrepareAsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>>(PrepareAsyncListReleasesRaw(context, request, cq));
    }
    // Gets details of a single Release.
    virtual ::grpc::Status GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::google::cloud::deploy::v1::Release* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>> AsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>>(AsyncGetReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>> PrepareAsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>>(PrepareAsyncGetReleaseRaw(context, request, cq));
    }
    // Creates a new Release in a given project and location.
    virtual ::grpc::Status CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateReleaseRaw(context, request, cq));
    }
    // Abandons a Release in the Delivery Pipeline.
    virtual ::grpc::Status AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>> AsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(AsyncAbandonReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>> PrepareAsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(PrepareAsyncAbandonReleaseRaw(context, request, cq));
    }
    // Approves a Rollout.
    virtual ::grpc::Status ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>> AsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(AsyncApproveRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>> PrepareAsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(PrepareAsyncApproveRolloutRaw(context, request, cq));
    }
    // Advances a Rollout in a given project and location.
    virtual ::grpc::Status AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> AsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(AsyncAdvanceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> PrepareAsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(PrepareAsyncAdvanceRolloutRaw(context, request, cq));
    }
    // Cancels a Rollout in a given project and location.
    virtual ::grpc::Status CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::google::cloud::deploy::v1::CancelRolloutResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>> AsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>>(AsyncCancelRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>> PrepareAsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>>(PrepareAsyncCancelRolloutRaw(context, request, cq));
    }
    // Lists Rollouts in a given project and location.
    virtual ::grpc::Status ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::google::cloud::deploy::v1::ListRolloutsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>> AsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>>(AsyncListRolloutsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>> PrepareAsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>>(PrepareAsyncListRolloutsRaw(context, request, cq));
    }
    // Gets details of a single Rollout.
    virtual ::grpc::Status GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::google::cloud::deploy::v1::Rollout* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>> AsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>>(AsyncGetRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>> PrepareAsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>>(PrepareAsyncGetRolloutRaw(context, request, cq));
    }
    // Creates a new Rollout in a given project and location.
    virtual ::grpc::Status CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateRolloutRaw(context, request, cq));
    }
    // Ignores the specified Job in a Rollout.
    virtual ::grpc::Status IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::google::cloud::deploy::v1::IgnoreJobResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>> AsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>>(AsyncIgnoreJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>> PrepareAsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>>(PrepareAsyncIgnoreJobRaw(context, request, cq));
    }
    // Retries the specified Job in a Rollout.
    virtual ::grpc::Status RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::google::cloud::deploy::v1::RetryJobResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>> AsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>>(AsyncRetryJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>> PrepareAsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>>(PrepareAsyncRetryJobRaw(context, request, cq));
    }
    // Lists JobRuns in a given project and location.
    virtual ::grpc::Status ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::google::cloud::deploy::v1::ListJobRunsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>> AsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>>(AsyncListJobRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>> PrepareAsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>>(PrepareAsyncListJobRunsRaw(context, request, cq));
    }
    // Gets details of a single JobRun.
    virtual ::grpc::Status GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::google::cloud::deploy::v1::JobRun* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>> AsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>>(AsyncGetJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>> PrepareAsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>>(PrepareAsyncGetJobRunRaw(context, request, cq));
    }
    // Terminates a Job Run in a given project and location.
    virtual ::grpc::Status TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>> AsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(AsyncTerminateJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>> PrepareAsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(PrepareAsyncTerminateJobRunRaw(context, request, cq));
    }
    // Gets the configuration for a location.
    virtual ::grpc::Status GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::google::cloud::deploy::v1::Config* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>> AsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>>(AsyncGetConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>> PrepareAsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>>(PrepareAsyncGetConfigRaw(context, request, cq));
    }
    // Creates a new Automation in a given project and location.
    virtual ::grpc::Status CreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAutomationRaw(context, request, cq));
    }
    // Updates the parameters of a single Automation resource.
    virtual ::grpc::Status UpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateAutomationRaw(context, request, cq));
    }
    // Deletes a single Automation resource.
    virtual ::grpc::Status DeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAutomationRaw(context, request, cq));
    }
    // Gets details of a single Automation.
    virtual ::grpc::Status GetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::google::cloud::deploy::v1::Automation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Automation>> AsyncGetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Automation>>(AsyncGetAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Automation>> PrepareAsyncGetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Automation>>(PrepareAsyncGetAutomationRaw(context, request, cq));
    }
    // Lists Automations in a given project and location.
    virtual ::grpc::Status ListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::google::cloud::deploy::v1::ListAutomationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationsResponse>> AsyncListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationsResponse>>(AsyncListAutomationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationsResponse>> PrepareAsyncListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationsResponse>>(PrepareAsyncListAutomationsRaw(context, request, cq));
    }
    // Gets details of a single AutomationRun.
    virtual ::grpc::Status GetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::google::cloud::deploy::v1::AutomationRun* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AutomationRun>> AsyncGetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AutomationRun>>(AsyncGetAutomationRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AutomationRun>> PrepareAsyncGetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AutomationRun>>(PrepareAsyncGetAutomationRunRaw(context, request, cq));
    }
    // Lists AutomationRuns in a given project and location.
    virtual ::grpc::Status ListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationRunsResponse>> AsyncListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationRunsResponse>>(AsyncListAutomationRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationRunsResponse>> PrepareAsyncListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationRunsResponse>>(PrepareAsyncListAutomationRunsRaw(context, request, cq));
    }
    // Cancels an AutomationRun. The `state` of the `AutomationRun` after
    // cancelling is `CANCELLED`. `CancelAutomationRun` can be called on
    // AutomationRun in the state `IN_PROGRESS` and `PENDING`; AutomationRun
    // in a different state returns an `FAILED_PRECONDITION` error.
    virtual ::grpc::Status CancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelAutomationRunResponse>> AsyncCancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelAutomationRunResponse>>(AsyncCancelAutomationRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelAutomationRunResponse>> PrepareAsyncCancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelAutomationRunResponse>>(PrepareAsyncCancelAutomationRunRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists DeliveryPipelines in a given project and location.
      virtual void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single DeliveryPipeline.
      virtual void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new DeliveryPipeline in a given project and location.
      virtual void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single DeliveryPipeline.
      virtual void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single DeliveryPipeline.
      virtual void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Targets in a given project and location.
      virtual void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a `Rollout` to roll back the specified target.
      virtual void RollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest* request, ::google::cloud::deploy::v1::RollbackTargetResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest* request, ::google::cloud::deploy::v1::RollbackTargetResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Target.
      virtual void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Target in a given project and location.
      virtual void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single Target.
      virtual void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Target.
      virtual void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists CustomTargetTypes in a given project and location.
      virtual void ListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single CustomTargetType.
      virtual void GetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* request, ::google::cloud::deploy::v1::CustomTargetType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* request, ::google::cloud::deploy::v1::CustomTargetType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new CustomTargetType in a given project and location.
      virtual void CreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a single CustomTargetType.
      virtual void UpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single CustomTargetType.
      virtual void DeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Releases in a given project and location.
      virtual void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Release.
      virtual void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Release in a given project and location.
      virtual void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Abandons a Release in the Delivery Pipeline.
      virtual void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Approves a Rollout.
      virtual void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Advances a Rollout in a given project and location.
      virtual void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels a Rollout in a given project and location.
      virtual void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Rollouts in a given project and location.
      virtual void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Rollout.
      virtual void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Rollout in a given project and location.
      virtual void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Ignores the specified Job in a Rollout.
      virtual void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retries the specified Job in a Rollout.
      virtual void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists JobRuns in a given project and location.
      virtual void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single JobRun.
      virtual void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Terminates a Job Run in a given project and location.
      virtual void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the configuration for a location.
      virtual void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Automation in a given project and location.
      virtual void CreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single Automation resource.
      virtual void UpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Automation resource.
      virtual void DeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Automation.
      virtual void GetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest* request, ::google::cloud::deploy::v1::Automation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest* request, ::google::cloud::deploy::v1::Automation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Automations in a given project and location.
      virtual void ListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest* request, ::google::cloud::deploy::v1::ListAutomationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest* request, ::google::cloud::deploy::v1::ListAutomationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single AutomationRun.
      virtual void GetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest* request, ::google::cloud::deploy::v1::AutomationRun* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest* request, ::google::cloud::deploy::v1::AutomationRun* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists AutomationRuns in a given project and location.
      virtual void ListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels an AutomationRun. The `state` of the `AutomationRun` after
      // cancelling is `CANCELLED`. `CancelAutomationRun` can be called on
      // AutomationRun in the state `IN_PROGRESS` and `PENDING`; AutomationRun
      // in a different state returns an `FAILED_PRECONDITION` error.
      virtual void CancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* AsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* PrepareAsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>* AsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::DeliveryPipeline>* PrepareAsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>* AsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListTargetsResponse>* PrepareAsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RollbackTargetResponse>* AsyncRollbackTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RollbackTargetResponse>* PrepareAsyncRollbackTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>* AsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Target>* PrepareAsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* AsyncListCustomTargetTypesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* PrepareAsyncListCustomTargetTypesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CustomTargetType>* AsyncGetCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CustomTargetType>* PrepareAsyncGetCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>* AsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListReleasesResponse>* PrepareAsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>* AsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Release>* PrepareAsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>* AsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AbandonReleaseResponse>* PrepareAsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>* AsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ApproveRolloutResponse>* PrepareAsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* AsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* PrepareAsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>* AsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelRolloutResponse>* PrepareAsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>* AsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListRolloutsResponse>* PrepareAsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>* AsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Rollout>* PrepareAsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>* AsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::IgnoreJobResponse>* PrepareAsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>* AsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::RetryJobResponse>* PrepareAsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>* AsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListJobRunsResponse>* PrepareAsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>* AsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::JobRun>* PrepareAsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>* AsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::TerminateJobRunResponse>* PrepareAsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>* AsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Config>* PrepareAsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Automation>* AsyncGetAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::Automation>* PrepareAsyncGetAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationsResponse>* AsyncListAutomationsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationsResponse>* PrepareAsyncListAutomationsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AutomationRun>* AsyncGetAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::AutomationRun>* PrepareAsyncGetAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationRunsResponse>* AsyncListAutomationRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::ListAutomationRunsResponse>* PrepareAsyncListAutomationRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelAutomationRunResponse>* AsyncCancelAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::deploy::v1::CancelAutomationRunResponse>* PrepareAsyncCancelAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> AsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(AsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>> PrepareAsyncListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>>(PrepareAsyncListDeliveryPipelinesRaw(context, request, cq));
    }
    ::grpc::Status GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::google::cloud::deploy::v1::DeliveryPipeline* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>> AsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>>(AsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>> PrepareAsyncGetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>>(PrepareAsyncGetDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteDeliveryPipelineRaw(context, request, cq));
    }
    ::grpc::Status ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::google::cloud::deploy::v1::ListTargetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>> AsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>>(AsyncListTargetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>> PrepareAsyncListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>>(PrepareAsyncListTargetsRaw(context, request, cq));
    }
    ::grpc::Status RollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::google::cloud::deploy::v1::RollbackTargetResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RollbackTargetResponse>> AsyncRollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RollbackTargetResponse>>(AsyncRollbackTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RollbackTargetResponse>> PrepareAsyncRollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RollbackTargetResponse>>(PrepareAsyncRollbackTargetRaw(context, request, cq));
    }
    ::grpc::Status GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::google::cloud::deploy::v1::Target* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>> AsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>>(AsyncGetTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>> PrepareAsyncGetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>>(PrepareAsyncGetTargetRaw(context, request, cq));
    }
    ::grpc::Status CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateTargetRaw(context, request, cq));
    }
    ::grpc::Status UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateTargetRaw(context, request, cq));
    }
    ::grpc::Status DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteTargetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteTargetRaw(context, request, cq));
    }
    ::grpc::Status ListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>> AsyncListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>>(AsyncListCustomTargetTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>> PrepareAsyncListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>>(PrepareAsyncListCustomTargetTypesRaw(context, request, cq));
    }
    ::grpc::Status GetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::google::cloud::deploy::v1::CustomTargetType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CustomTargetType>> AsyncGetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CustomTargetType>>(AsyncGetCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CustomTargetType>> PrepareAsyncGetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CustomTargetType>>(PrepareAsyncGetCustomTargetTypeRaw(context, request, cq));
    }
    ::grpc::Status CreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateCustomTargetTypeRaw(context, request, cq));
    }
    ::grpc::Status UpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateCustomTargetTypeRaw(context, request, cq));
    }
    ::grpc::Status DeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteCustomTargetTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteCustomTargetTypeRaw(context, request, cq));
    }
    ::grpc::Status ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::google::cloud::deploy::v1::ListReleasesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>> AsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>>(AsyncListReleasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>> PrepareAsyncListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>>(PrepareAsyncListReleasesRaw(context, request, cq));
    }
    ::grpc::Status GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::google::cloud::deploy::v1::Release* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>> AsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>>(AsyncGetReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>> PrepareAsyncGetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>>(PrepareAsyncGetReleaseRaw(context, request, cq));
    }
    ::grpc::Status CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateReleaseRaw(context, request, cq));
    }
    ::grpc::Status AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>> AsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(AsyncAbandonReleaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>> PrepareAsyncAbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>>(PrepareAsyncAbandonReleaseRaw(context, request, cq));
    }
    ::grpc::Status ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>> AsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(AsyncApproveRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>> PrepareAsyncApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>>(PrepareAsyncApproveRolloutRaw(context, request, cq));
    }
    ::grpc::Status AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> AsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(AsyncAdvanceRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>> PrepareAsyncAdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>>(PrepareAsyncAdvanceRolloutRaw(context, request, cq));
    }
    ::grpc::Status CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::google::cloud::deploy::v1::CancelRolloutResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>> AsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>>(AsyncCancelRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>> PrepareAsyncCancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>>(PrepareAsyncCancelRolloutRaw(context, request, cq));
    }
    ::grpc::Status ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::google::cloud::deploy::v1::ListRolloutsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>> AsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>>(AsyncListRolloutsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>> PrepareAsyncListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>>(PrepareAsyncListRolloutsRaw(context, request, cq));
    }
    ::grpc::Status GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::google::cloud::deploy::v1::Rollout* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>> AsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>>(AsyncGetRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>> PrepareAsyncGetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>>(PrepareAsyncGetRolloutRaw(context, request, cq));
    }
    ::grpc::Status CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateRolloutRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateRolloutRaw(context, request, cq));
    }
    ::grpc::Status IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::google::cloud::deploy::v1::IgnoreJobResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>> AsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>>(AsyncIgnoreJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>> PrepareAsyncIgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>>(PrepareAsyncIgnoreJobRaw(context, request, cq));
    }
    ::grpc::Status RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::google::cloud::deploy::v1::RetryJobResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>> AsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>>(AsyncRetryJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>> PrepareAsyncRetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>>(PrepareAsyncRetryJobRaw(context, request, cq));
    }
    ::grpc::Status ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::google::cloud::deploy::v1::ListJobRunsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>> AsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>>(AsyncListJobRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>> PrepareAsyncListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>>(PrepareAsyncListJobRunsRaw(context, request, cq));
    }
    ::grpc::Status GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::google::cloud::deploy::v1::JobRun* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>> AsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>>(AsyncGetJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>> PrepareAsyncGetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>>(PrepareAsyncGetJobRunRaw(context, request, cq));
    }
    ::grpc::Status TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>> AsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(AsyncTerminateJobRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>> PrepareAsyncTerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>>(PrepareAsyncTerminateJobRunRaw(context, request, cq));
    }
    ::grpc::Status GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::google::cloud::deploy::v1::Config* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>> AsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>>(AsyncGetConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>> PrepareAsyncGetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>>(PrepareAsyncGetConfigRaw(context, request, cq));
    }
    ::grpc::Status CreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAutomationRaw(context, request, cq));
    }
    ::grpc::Status UpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateAutomationRaw(context, request, cq));
    }
    ::grpc::Status DeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAutomationRaw(context, request, cq));
    }
    ::grpc::Status GetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::google::cloud::deploy::v1::Automation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Automation>> AsyncGetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Automation>>(AsyncGetAutomationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Automation>> PrepareAsyncGetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Automation>>(PrepareAsyncGetAutomationRaw(context, request, cq));
    }
    ::grpc::Status ListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::google::cloud::deploy::v1::ListAutomationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationsResponse>> AsyncListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationsResponse>>(AsyncListAutomationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationsResponse>> PrepareAsyncListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationsResponse>>(PrepareAsyncListAutomationsRaw(context, request, cq));
    }
    ::grpc::Status GetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::google::cloud::deploy::v1::AutomationRun* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AutomationRun>> AsyncGetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AutomationRun>>(AsyncGetAutomationRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AutomationRun>> PrepareAsyncGetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AutomationRun>>(PrepareAsyncGetAutomationRunRaw(context, request, cq));
    }
    ::grpc::Status ListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationRunsResponse>> AsyncListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationRunsResponse>>(AsyncListAutomationRunsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationRunsResponse>> PrepareAsyncListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationRunsResponse>>(PrepareAsyncListAutomationRunsRaw(context, request, cq));
    }
    ::grpc::Status CancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelAutomationRunResponse>> AsyncCancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelAutomationRunResponse>>(AsyncCancelAutomationRunRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelAutomationRunResponse>> PrepareAsyncCancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelAutomationRunResponse>>(PrepareAsyncCancelAutomationRunRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDeliveryPipelines(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, std::function<void(::grpc::Status)>) override;
      void GetDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteDeliveryPipeline(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTargets(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest* request, ::google::cloud::deploy::v1::RollbackTargetResponse* response, std::function<void(::grpc::Status)>) override;
      void RollbackTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest* request, ::google::cloud::deploy::v1::RollbackTargetResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, std::function<void(::grpc::Status)>) override;
      void GetTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteTarget(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCustomTargetTypes(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* request, ::google::cloud::deploy::v1::CustomTargetType* response, std::function<void(::grpc::Status)>) override;
      void GetCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* request, ::google::cloud::deploy::v1::CustomTargetType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCustomTargetType(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListReleases(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, std::function<void(::grpc::Status)>) override;
      void GetRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, std::function<void(::grpc::Status)>) override;
      void AbandonRelease(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, std::function<void(::grpc::Status)>) override;
      void ApproveRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, std::function<void(::grpc::Status)>) override;
      void AdvanceRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, std::function<void(::grpc::Status)>) override;
      void CancelRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRollouts(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, std::function<void(::grpc::Status)>) override;
      void GetRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateRollout(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, std::function<void(::grpc::Status)>) override;
      void IgnoreJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, std::function<void(::grpc::Status)>) override;
      void RetryJob(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, std::function<void(::grpc::Status)>) override;
      void GetJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, std::function<void(::grpc::Status)>) override;
      void TerminateJobRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, std::function<void(::grpc::Status)>) override;
      void GetConfig(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest* request, ::google::cloud::deploy::v1::Automation* response, std::function<void(::grpc::Status)>) override;
      void GetAutomation(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest* request, ::google::cloud::deploy::v1::Automation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest* request, ::google::cloud::deploy::v1::ListAutomationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAutomations(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest* request, ::google::cloud::deploy::v1::ListAutomationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest* request, ::google::cloud::deploy::v1::AutomationRun* response, std::function<void(::grpc::Status)>) override;
      void GetAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest* request, ::google::cloud::deploy::v1::AutomationRun* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAutomationRuns(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response, std::function<void(::grpc::Status)>) override;
      void CancelAutomationRun(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* AsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* PrepareAsyncListDeliveryPipelinesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>* AsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::DeliveryPipeline>* PrepareAsyncGetDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteDeliveryPipelineRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>* AsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListTargetsResponse>* PrepareAsyncListTargetsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RollbackTargetResponse>* AsyncRollbackTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RollbackTargetResponse>* PrepareAsyncRollbackTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>* AsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Target>* PrepareAsyncGetTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteTargetRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* AsyncListCustomTargetTypesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* PrepareAsyncListCustomTargetTypesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CustomTargetType>* AsyncGetCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CustomTargetType>* PrepareAsyncGetCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteCustomTargetTypeRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>* AsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListReleasesResponse>* PrepareAsyncListReleasesRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>* AsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Release>* PrepareAsyncGetReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>* AsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AbandonReleaseResponse>* PrepareAsyncAbandonReleaseRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>* AsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ApproveRolloutResponse>* PrepareAsyncApproveRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* AsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* PrepareAsyncAdvanceRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>* AsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelRolloutResponse>* PrepareAsyncCancelRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>* AsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListRolloutsResponse>* PrepareAsyncListRolloutsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>* AsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Rollout>* PrepareAsyncGetRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateRolloutRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>* AsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::IgnoreJobResponse>* PrepareAsyncIgnoreJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>* AsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::RetryJobResponse>* PrepareAsyncRetryJobRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::RetryJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>* AsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListJobRunsResponse>* PrepareAsyncListJobRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>* AsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::JobRun>* PrepareAsyncGetJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>* AsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::TerminateJobRunResponse>* PrepareAsyncTerminateJobRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>* AsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Config>* PrepareAsyncGetConfigRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Automation>* AsyncGetAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::Automation>* PrepareAsyncGetAutomationRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationsResponse>* AsyncListAutomationsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationsResponse>* PrepareAsyncListAutomationsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AutomationRun>* AsyncGetAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::AutomationRun>* PrepareAsyncGetAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationRunsResponse>* AsyncListAutomationRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::ListAutomationRunsResponse>* PrepareAsyncListAutomationRunsRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelAutomationRunResponse>* AsyncCancelAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::deploy::v1::CancelAutomationRunResponse>* PrepareAsyncCancelAutomationRunRaw(::grpc::ClientContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListDeliveryPipelines_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDeliveryPipeline_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTargets_;
    const ::grpc::internal::RpcMethod rpcmethod_RollbackTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTarget_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCustomTargetTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCustomTargetType_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCustomTargetType_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCustomTargetType_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCustomTargetType_;
    const ::grpc::internal::RpcMethod rpcmethod_ListReleases_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRelease_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRelease_;
    const ::grpc::internal::RpcMethod rpcmethod_AbandonRelease_;
    const ::grpc::internal::RpcMethod rpcmethod_ApproveRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_AdvanceRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRollouts_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRollout_;
    const ::grpc::internal::RpcMethod rpcmethod_IgnoreJob_;
    const ::grpc::internal::RpcMethod rpcmethod_RetryJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobRuns_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJobRun_;
    const ::grpc::internal::RpcMethod rpcmethod_TerminateJobRun_;
    const ::grpc::internal::RpcMethod rpcmethod_GetConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAutomation_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAutomation_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAutomation_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAutomation_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAutomations_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAutomationRun_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAutomationRuns_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelAutomationRun_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists DeliveryPipelines in a given project and location.
    virtual ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response);
    // Gets details of a single DeliveryPipeline.
    virtual ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response);
    // Creates a new DeliveryPipeline in a given project and location.
    virtual ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single DeliveryPipeline.
    virtual ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single DeliveryPipeline.
    virtual ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response);
    // Lists Targets in a given project and location.
    virtual ::grpc::Status ListTargets(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response);
    // Creates a `Rollout` to roll back the specified target.
    virtual ::grpc::Status RollbackTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest* request, ::google::cloud::deploy::v1::RollbackTargetResponse* response);
    // Gets details of a single Target.
    virtual ::grpc::Status GetTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response);
    // Creates a new Target in a given project and location.
    virtual ::grpc::Status CreateTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single Target.
    virtual ::grpc::Status UpdateTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Target.
    virtual ::grpc::Status DeleteTarget(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response);
    // Lists CustomTargetTypes in a given project and location.
    virtual ::grpc::Status ListCustomTargetTypes(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response);
    // Gets details of a single CustomTargetType.
    virtual ::grpc::Status GetCustomTargetType(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* request, ::google::cloud::deploy::v1::CustomTargetType* response);
    // Creates a new CustomTargetType in a given project and location.
    virtual ::grpc::Status CreateCustomTargetType(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response);
    // Updates a single CustomTargetType.
    virtual ::grpc::Status UpdateCustomTargetType(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single CustomTargetType.
    virtual ::grpc::Status DeleteCustomTargetType(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* request, ::google::longrunning::Operation* response);
    // Lists Releases in a given project and location.
    virtual ::grpc::Status ListReleases(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response);
    // Gets details of a single Release.
    virtual ::grpc::Status GetRelease(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response);
    // Creates a new Release in a given project and location.
    virtual ::grpc::Status CreateRelease(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response);
    // Abandons a Release in the Delivery Pipeline.
    virtual ::grpc::Status AbandonRelease(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response);
    // Approves a Rollout.
    virtual ::grpc::Status ApproveRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response);
    // Advances a Rollout in a given project and location.
    virtual ::grpc::Status AdvanceRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response);
    // Cancels a Rollout in a given project and location.
    virtual ::grpc::Status CancelRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response);
    // Lists Rollouts in a given project and location.
    virtual ::grpc::Status ListRollouts(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response);
    // Gets details of a single Rollout.
    virtual ::grpc::Status GetRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response);
    // Creates a new Rollout in a given project and location.
    virtual ::grpc::Status CreateRollout(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response);
    // Ignores the specified Job in a Rollout.
    virtual ::grpc::Status IgnoreJob(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response);
    // Retries the specified Job in a Rollout.
    virtual ::grpc::Status RetryJob(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response);
    // Lists JobRuns in a given project and location.
    virtual ::grpc::Status ListJobRuns(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response);
    // Gets details of a single JobRun.
    virtual ::grpc::Status GetJobRun(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response);
    // Terminates a Job Run in a given project and location.
    virtual ::grpc::Status TerminateJobRun(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response);
    // Gets the configuration for a location.
    virtual ::grpc::Status GetConfig(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response);
    // Creates a new Automation in a given project and location.
    virtual ::grpc::Status CreateAutomation(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single Automation resource.
    virtual ::grpc::Status UpdateAutomation(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Automation resource.
    virtual ::grpc::Status DeleteAutomation(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest* request, ::google::longrunning::Operation* response);
    // Gets details of a single Automation.
    virtual ::grpc::Status GetAutomation(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest* request, ::google::cloud::deploy::v1::Automation* response);
    // Lists Automations in a given project and location.
    virtual ::grpc::Status ListAutomations(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest* request, ::google::cloud::deploy::v1::ListAutomationsResponse* response);
    // Gets details of a single AutomationRun.
    virtual ::grpc::Status GetAutomationRun(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest* request, ::google::cloud::deploy::v1::AutomationRun* response);
    // Lists AutomationRuns in a given project and location.
    virtual ::grpc::Status ListAutomationRuns(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response);
    // Cancels an AutomationRun. The `state` of the `AutomationRun` after
    // cancelling is `CANCELLED`. `CancelAutomationRun` can be called on
    // AutomationRun in the state `IN_PROGRESS` and `PENDING`; AutomationRun
    // in a different state returns an `FAILED_PRECONDITION` error.
    virtual ::grpc::Status CancelAutomationRun(::grpc::ServerContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeliveryPipelines(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::DeliveryPipeline>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDeliveryPipeline(::grpc::ServerContext* context, ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTargets() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTargets(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListTargetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListTargetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RollbackTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RollbackTarget() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_RollbackTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RollbackTargetRequest* /*request*/, ::google::cloud::deploy::v1::RollbackTargetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRollbackTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::RollbackTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::RollbackTargetResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTarget() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Target>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTarget() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTarget(::grpc::ServerContext* context, ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCustomTargetTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCustomTargetTypes() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListCustomTargetTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomTargetTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* /*request*/, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomTargetTypes(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCustomTargetType() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* /*request*/, ::google::cloud::deploy::v1::CustomTargetType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomTargetType(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::CustomTargetType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCustomTargetType() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_CreateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomTargetType(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCustomTargetType() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_UpdateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomTargetType(::grpc::ServerContext* context, ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCustomTargetType() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_DeleteCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomTargetType(::grpc::ServerContext* context, ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListReleases() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReleases(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListReleasesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListReleasesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRelease() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRelease(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetReleaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Release>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRelease() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRelease(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAbandonRelease(::grpc::ServerContext* context, ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::AbandonReleaseResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ApproveRolloutResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAdvanceRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::AdvanceRolloutResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelRollout() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::CancelRolloutResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRollouts() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRollouts(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListRolloutsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRollout() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Rollout>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRollout() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRollout(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestIgnoreJob(::grpc::ServerContext* context, ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::IgnoreJobResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RetryJob() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetryJob(::grpc::ServerContext* context, ::google::cloud::deploy::v1::RetryJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::RetryJobResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobRuns(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListJobRunsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJobRun() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobRun(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetJobRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::JobRun>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTerminateJobRun(::grpc::ServerContext* context, ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::TerminateJobRunResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetConfig() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConfig(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Config>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAutomation() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_CreateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAutomation(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CreateAutomationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAutomation() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_UpdateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAutomation(::grpc::ServerContext* context, ::google::cloud::deploy::v1::UpdateAutomationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAutomation() {
      ::grpc::Service::MarkMethodAsync(34);
    }
    ~WithAsyncMethod_DeleteAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAutomation(::grpc::ServerContext* context, ::google::cloud::deploy::v1::DeleteAutomationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAutomation() {
      ::grpc::Service::MarkMethodAsync(35);
    }
    ~WithAsyncMethod_GetAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRequest* /*request*/, ::google::cloud::deploy::v1::Automation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutomation(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetAutomationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::Automation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAutomations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAutomations() {
      ::grpc::Service::MarkMethodAsync(36);
    }
    ~WithAsyncMethod_ListAutomations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomations(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAutomations(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListAutomationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListAutomationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAutomationRun() {
      ::grpc::Service::MarkMethodAsync(37);
    }
    ~WithAsyncMethod_GetAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::AutomationRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutomationRun(::grpc::ServerContext* context, ::google::cloud::deploy::v1::GetAutomationRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::AutomationRun>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAutomationRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAutomationRuns() {
      ::grpc::Service::MarkMethodAsync(38);
    }
    ~WithAsyncMethod_ListAutomationRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomationRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAutomationRuns(::grpc::ServerContext* context, ::google::cloud::deploy::v1::ListAutomationRunsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::ListAutomationRunsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelAutomationRun() {
      ::grpc::Service::MarkMethodAsync(39);
    }
    ~WithAsyncMethod_CancelAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::CancelAutomationRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelAutomationRun(::grpc::ServerContext* context, ::google::cloud::deploy::v1::CancelAutomationRunRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::deploy::v1::CancelAutomationRunResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListDeliveryPipelines<WithAsyncMethod_GetDeliveryPipeline<WithAsyncMethod_CreateDeliveryPipeline<WithAsyncMethod_UpdateDeliveryPipeline<WithAsyncMethod_DeleteDeliveryPipeline<WithAsyncMethod_ListTargets<WithAsyncMethod_RollbackTarget<WithAsyncMethod_GetTarget<WithAsyncMethod_CreateTarget<WithAsyncMethod_UpdateTarget<WithAsyncMethod_DeleteTarget<WithAsyncMethod_ListCustomTargetTypes<WithAsyncMethod_GetCustomTargetType<WithAsyncMethod_CreateCustomTargetType<WithAsyncMethod_UpdateCustomTargetType<WithAsyncMethod_DeleteCustomTargetType<WithAsyncMethod_ListReleases<WithAsyncMethod_GetRelease<WithAsyncMethod_CreateRelease<WithAsyncMethod_AbandonRelease<WithAsyncMethod_ApproveRollout<WithAsyncMethod_AdvanceRollout<WithAsyncMethod_CancelRollout<WithAsyncMethod_ListRollouts<WithAsyncMethod_GetRollout<WithAsyncMethod_CreateRollout<WithAsyncMethod_IgnoreJob<WithAsyncMethod_RetryJob<WithAsyncMethod_ListJobRuns<WithAsyncMethod_GetJobRun<WithAsyncMethod_TerminateJobRun<WithAsyncMethod_GetConfig<WithAsyncMethod_CreateAutomation<WithAsyncMethod_UpdateAutomation<WithAsyncMethod_DeleteAutomation<WithAsyncMethod_GetAutomation<WithAsyncMethod_ListAutomations<WithAsyncMethod_GetAutomationRun<WithAsyncMethod_ListAutomationRuns<WithAsyncMethod_CancelAutomationRun<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* request, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* response) { return this->ListDeliveryPipelines(context, request, response); }));}
    void SetMessageAllocatorFor_ListDeliveryPipelines(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeliveryPipelines(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* request, ::google::cloud::deploy::v1::DeliveryPipeline* response) { return this->GetDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_GetDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response) { return this->CreateDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* request, ::google::longrunning::Operation* response) { return this->UpdateDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* request, ::google::longrunning::Operation* response) { return this->DeleteDeliveryPipeline(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDeliveryPipeline(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTargets() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListTargetsRequest* request, ::google::cloud::deploy::v1::ListTargetsResponse* response) { return this->ListTargets(context, request, response); }));}
    void SetMessageAllocatorFor_ListTargets(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTargets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RollbackTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RollbackTarget() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::RollbackTargetRequest, ::google::cloud::deploy::v1::RollbackTargetResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::RollbackTargetRequest* request, ::google::cloud::deploy::v1::RollbackTargetResponse* response) { return this->RollbackTarget(context, request, response); }));}
    void SetMessageAllocatorFor_RollbackTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::RollbackTargetRequest, ::google::cloud::deploy::v1::RollbackTargetResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::RollbackTargetRequest, ::google::cloud::deploy::v1::RollbackTargetResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RollbackTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RollbackTargetRequest* /*request*/, ::google::cloud::deploy::v1::RollbackTargetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RollbackTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::RollbackTargetRequest* /*request*/, ::google::cloud::deploy::v1::RollbackTargetResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTarget() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetTargetRequest* request, ::google::cloud::deploy::v1::Target* response) { return this->GetTarget(context, request, response); }));}
    void SetMessageAllocatorFor_GetTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTarget() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateTargetRequest* request, ::google::longrunning::Operation* response) { return this->CreateTarget(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::UpdateTargetRequest* request, ::google::longrunning::Operation* response) { return this->UpdateTarget(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::DeleteTargetRequest* request, ::google::longrunning::Operation* response) { return this->DeleteTarget(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTarget(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCustomTargetTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCustomTargetTypes() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListCustomTargetTypesRequest, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* request, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* response) { return this->ListCustomTargetTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListCustomTargetTypes(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListCustomTargetTypesRequest, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListCustomTargetTypesRequest, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCustomTargetTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomTargetTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* /*request*/, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomTargetTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* /*request*/, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCustomTargetType() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetCustomTargetTypeRequest, ::google::cloud::deploy::v1::CustomTargetType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* request, ::google::cloud::deploy::v1::CustomTargetType* response) { return this->GetCustomTargetType(context, request, response); }));}
    void SetMessageAllocatorFor_GetCustomTargetType(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetCustomTargetTypeRequest, ::google::cloud::deploy::v1::CustomTargetType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetCustomTargetTypeRequest, ::google::cloud::deploy::v1::CustomTargetType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* /*request*/, ::google::cloud::deploy::v1::CustomTargetType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* /*request*/, ::google::cloud::deploy::v1::CustomTargetType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCustomTargetType() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response) { return this->CreateCustomTargetType(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCustomTargetType(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCustomTargetType() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCustomTargetType(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCustomTargetType(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCustomTargetType() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCustomTargetType(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCustomTargetType(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListReleases() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListReleasesRequest* request, ::google::cloud::deploy::v1::ListReleasesResponse* response) { return this->ListReleases(context, request, response); }));}
    void SetMessageAllocatorFor_ListReleases(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReleases(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRelease() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetReleaseRequest* request, ::google::cloud::deploy::v1::Release* response) { return this->GetRelease(context, request, response); }));}
    void SetMessageAllocatorFor_GetRelease(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRelease() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateReleaseRequest* request, ::google::longrunning::Operation* response) { return this->CreateRelease(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRelease(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::AbandonReleaseRequest* request, ::google::cloud::deploy::v1::AbandonReleaseResponse* response) { return this->AbandonRelease(context, request, response); }));}
    void SetMessageAllocatorFor_AbandonRelease(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AbandonRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ApproveRolloutRequest* request, ::google::cloud::deploy::v1::ApproveRolloutResponse* response) { return this->ApproveRollout(context, request, response); }));}
    void SetMessageAllocatorFor_ApproveRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* request, ::google::cloud::deploy::v1::AdvanceRolloutResponse* response) { return this->AdvanceRollout(context, request, response); }));}
    void SetMessageAllocatorFor_AdvanceRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AdvanceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelRollout() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CancelRolloutRequest* request, ::google::cloud::deploy::v1::CancelRolloutResponse* response) { return this->CancelRollout(context, request, response); }));}
    void SetMessageAllocatorFor_CancelRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRollouts() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListRolloutsRequest* request, ::google::cloud::deploy::v1::ListRolloutsResponse* response) { return this->ListRollouts(context, request, response); }));}
    void SetMessageAllocatorFor_ListRollouts(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRollouts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRollout() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetRolloutRequest* request, ::google::cloud::deploy::v1::Rollout* response) { return this->GetRollout(context, request, response); }));}
    void SetMessageAllocatorFor_GetRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRollout() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateRolloutRequest* request, ::google::longrunning::Operation* response) { return this->CreateRollout(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRollout(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::IgnoreJobRequest* request, ::google::cloud::deploy::v1::IgnoreJobResponse* response) { return this->IgnoreJob(context, request, response); }));}
    void SetMessageAllocatorFor_IgnoreJob(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* IgnoreJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RetryJob() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::RetryJobRequest* request, ::google::cloud::deploy::v1::RetryJobResponse* response) { return this->RetryJob(context, request, response); }));}
    void SetMessageAllocatorFor_RetryJob(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetryJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListJobRunsRequest* request, ::google::cloud::deploy::v1::ListJobRunsResponse* response) { return this->ListJobRuns(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobRuns(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJobRun() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetJobRunRequest* request, ::google::cloud::deploy::v1::JobRun* response) { return this->GetJobRun(context, request, response); }));}
    void SetMessageAllocatorFor_GetJobRun(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::TerminateJobRunRequest* request, ::google::cloud::deploy::v1::TerminateJobRunResponse* response) { return this->TerminateJobRun(context, request, response); }));}
    void SetMessageAllocatorFor_TerminateJobRun(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TerminateJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetConfig() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetConfigRequest* request, ::google::cloud::deploy::v1::Config* response) { return this->GetConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetConfig(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAutomation() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateAutomationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CreateAutomationRequest* request, ::google::longrunning::Operation* response) { return this->CreateAutomation(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAutomation(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CreateAutomationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CreateAutomationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAutomation() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateAutomationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::UpdateAutomationRequest* request, ::google::longrunning::Operation* response) { return this->UpdateAutomation(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAutomation(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::UpdateAutomationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::UpdateAutomationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAutomation() {
      ::grpc::Service::MarkMethodCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteAutomationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::DeleteAutomationRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAutomation(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAutomation(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::DeleteAutomationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(34);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::DeleteAutomationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAutomation() {
      ::grpc::Service::MarkMethodCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetAutomationRequest, ::google::cloud::deploy::v1::Automation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetAutomationRequest* request, ::google::cloud::deploy::v1::Automation* response) { return this->GetAutomation(context, request, response); }));}
    void SetMessageAllocatorFor_GetAutomation(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetAutomationRequest, ::google::cloud::deploy::v1::Automation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(35);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetAutomationRequest, ::google::cloud::deploy::v1::Automation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRequest* /*request*/, ::google::cloud::deploy::v1::Automation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRequest* /*request*/, ::google::cloud::deploy::v1::Automation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAutomations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAutomations() {
      ::grpc::Service::MarkMethodCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListAutomationsRequest, ::google::cloud::deploy::v1::ListAutomationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListAutomationsRequest* request, ::google::cloud::deploy::v1::ListAutomationsResponse* response) { return this->ListAutomations(context, request, response); }));}
    void SetMessageAllocatorFor_ListAutomations(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListAutomationsRequest, ::google::cloud::deploy::v1::ListAutomationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(36);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListAutomationsRequest, ::google::cloud::deploy::v1::ListAutomationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAutomations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomations(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAutomations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAutomationRun() {
      ::grpc::Service::MarkMethodCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetAutomationRunRequest, ::google::cloud::deploy::v1::AutomationRun>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::GetAutomationRunRequest* request, ::google::cloud::deploy::v1::AutomationRun* response) { return this->GetAutomationRun(context, request, response); }));}
    void SetMessageAllocatorFor_GetAutomationRun(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::GetAutomationRunRequest, ::google::cloud::deploy::v1::AutomationRun>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(37);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::GetAutomationRunRequest, ::google::cloud::deploy::v1::AutomationRun>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::AutomationRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutomationRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::AutomationRun* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAutomationRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAutomationRuns() {
      ::grpc::Service::MarkMethodCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListAutomationRunsRequest, ::google::cloud::deploy::v1::ListAutomationRunsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* request, ::google::cloud::deploy::v1::ListAutomationRunsResponse* response) { return this->ListAutomationRuns(context, request, response); }));}
    void SetMessageAllocatorFor_ListAutomationRuns(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::ListAutomationRunsRequest, ::google::cloud::deploy::v1::ListAutomationRunsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(38);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::ListAutomationRunsRequest, ::google::cloud::deploy::v1::ListAutomationRunsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAutomationRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomationRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAutomationRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationRunsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelAutomationRun() {
      ::grpc::Service::MarkMethodCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CancelAutomationRunRequest, ::google::cloud::deploy::v1::CancelAutomationRunResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* request, ::google::cloud::deploy::v1::CancelAutomationRunResponse* response) { return this->CancelAutomationRun(context, request, response); }));}
    void SetMessageAllocatorFor_CancelAutomationRun(
        ::grpc::MessageAllocator< ::google::cloud::deploy::v1::CancelAutomationRunRequest, ::google::cloud::deploy::v1::CancelAutomationRunResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(39);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::deploy::v1::CancelAutomationRunRequest, ::google::cloud::deploy::v1::CancelAutomationRunResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::CancelAutomationRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelAutomationRun(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::CancelAutomationRunResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListDeliveryPipelines<WithCallbackMethod_GetDeliveryPipeline<WithCallbackMethod_CreateDeliveryPipeline<WithCallbackMethod_UpdateDeliveryPipeline<WithCallbackMethod_DeleteDeliveryPipeline<WithCallbackMethod_ListTargets<WithCallbackMethod_RollbackTarget<WithCallbackMethod_GetTarget<WithCallbackMethod_CreateTarget<WithCallbackMethod_UpdateTarget<WithCallbackMethod_DeleteTarget<WithCallbackMethod_ListCustomTargetTypes<WithCallbackMethod_GetCustomTargetType<WithCallbackMethod_CreateCustomTargetType<WithCallbackMethod_UpdateCustomTargetType<WithCallbackMethod_DeleteCustomTargetType<WithCallbackMethod_ListReleases<WithCallbackMethod_GetRelease<WithCallbackMethod_CreateRelease<WithCallbackMethod_AbandonRelease<WithCallbackMethod_ApproveRollout<WithCallbackMethod_AdvanceRollout<WithCallbackMethod_CancelRollout<WithCallbackMethod_ListRollouts<WithCallbackMethod_GetRollout<WithCallbackMethod_CreateRollout<WithCallbackMethod_IgnoreJob<WithCallbackMethod_RetryJob<WithCallbackMethod_ListJobRuns<WithCallbackMethod_GetJobRun<WithCallbackMethod_TerminateJobRun<WithCallbackMethod_GetConfig<WithCallbackMethod_CreateAutomation<WithCallbackMethod_UpdateAutomation<WithCallbackMethod_DeleteAutomation<WithCallbackMethod_GetAutomation<WithCallbackMethod_ListAutomations<WithCallbackMethod_GetAutomationRun<WithCallbackMethod_ListAutomationRuns<WithCallbackMethod_CancelAutomationRun<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTargets() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RollbackTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RollbackTarget() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_RollbackTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RollbackTargetRequest* /*request*/, ::google::cloud::deploy::v1::RollbackTargetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTarget() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTarget() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCustomTargetTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCustomTargetTypes() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListCustomTargetTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomTargetTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* /*request*/, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCustomTargetType() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* /*request*/, ::google::cloud::deploy::v1::CustomTargetType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCustomTargetType() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_CreateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCustomTargetType() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_UpdateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCustomTargetType() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_DeleteCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListReleases() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRelease() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRelease() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelRollout() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRollouts() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRollout() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRollout() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RetryJob() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJobRun() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetConfig() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAutomation() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_CreateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAutomation() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_UpdateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAutomation() {
      ::grpc::Service::MarkMethodGeneric(34);
    }
    ~WithGenericMethod_DeleteAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAutomation() {
      ::grpc::Service::MarkMethodGeneric(35);
    }
    ~WithGenericMethod_GetAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRequest* /*request*/, ::google::cloud::deploy::v1::Automation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAutomations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAutomations() {
      ::grpc::Service::MarkMethodGeneric(36);
    }
    ~WithGenericMethod_ListAutomations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomations(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAutomationRun() {
      ::grpc::Service::MarkMethodGeneric(37);
    }
    ~WithGenericMethod_GetAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::AutomationRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAutomationRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAutomationRuns() {
      ::grpc::Service::MarkMethodGeneric(38);
    }
    ~WithGenericMethod_ListAutomationRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomationRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelAutomationRun() {
      ::grpc::Service::MarkMethodGeneric(39);
    }
    ~WithGenericMethod_CancelAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::CancelAutomationRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeliveryPipelines(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTargets() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTargets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RollbackTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RollbackTarget() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_RollbackTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RollbackTargetRequest* /*request*/, ::google::cloud::deploy::v1::RollbackTargetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRollbackTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTarget() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTarget() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTarget(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCustomTargetTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCustomTargetTypes() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListCustomTargetTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomTargetTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* /*request*/, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomTargetTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCustomTargetType() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* /*request*/, ::google::cloud::deploy::v1::CustomTargetType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomTargetType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCustomTargetType() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_CreateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomTargetType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCustomTargetType() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_UpdateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomTargetType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCustomTargetType() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_DeleteCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomTargetType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListReleases() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReleases(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRelease() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRelease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRelease() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRelease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAbandonRelease(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAdvanceRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelRollout() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRollouts() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRollouts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRollout() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRollout() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRollout(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestIgnoreJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RetryJob() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRetryJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobRuns(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJobRun() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJobRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTerminateJobRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetConfig() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAutomation() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_CreateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAutomation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAutomation() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_UpdateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAutomation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAutomation() {
      ::grpc::Service::MarkMethodRaw(34);
    }
    ~WithRawMethod_DeleteAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAutomation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAutomation() {
      ::grpc::Service::MarkMethodRaw(35);
    }
    ~WithRawMethod_GetAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRequest* /*request*/, ::google::cloud::deploy::v1::Automation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutomation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAutomations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAutomations() {
      ::grpc::Service::MarkMethodRaw(36);
    }
    ~WithRawMethod_ListAutomations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomations(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAutomations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAutomationRun() {
      ::grpc::Service::MarkMethodRaw(37);
    }
    ~WithRawMethod_GetAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::AutomationRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutomationRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAutomationRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAutomationRuns() {
      ::grpc::Service::MarkMethodRaw(38);
    }
    ~WithRawMethod_ListAutomationRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomationRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAutomationRuns(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelAutomationRun() {
      ::grpc::Service::MarkMethodRaw(39);
    }
    ~WithRawMethod_CancelAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::CancelAutomationRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelAutomationRun(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDeliveryPipelines(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeliveryPipelines(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDeliveryPipeline(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDeliveryPipeline(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTargets() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTargets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTargets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RollbackTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RollbackTarget() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RollbackTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_RollbackTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RollbackTargetRequest* /*request*/, ::google::cloud::deploy::v1::RollbackTargetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RollbackTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTarget() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTarget() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTarget(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTarget(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCustomTargetTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCustomTargetTypes() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCustomTargetTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCustomTargetTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomTargetTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* /*request*/, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomTargetTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCustomTargetType() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCustomTargetType(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* /*request*/, ::google::cloud::deploy::v1::CustomTargetType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCustomTargetType() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCustomTargetType(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCustomTargetType() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCustomTargetType(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCustomTargetType() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCustomTargetType(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomTargetType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListReleases() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListReleases(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReleases(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRelease() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRelease(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRelease() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRelease(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AbandonRelease(context, request, response); }));
    }
    ~WithRawCallbackMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AbandonRelease(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApproveRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AdvanceRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AdvanceRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelRollout() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRollouts() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRollouts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRollouts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRollout() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRollout() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRollout(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRollout(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->IgnoreJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* IgnoreJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RetryJob() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RetryJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RetryJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobRuns(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJobRun() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJobRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TerminateJobRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TerminateJobRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetConfig() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAutomation() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAutomation(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAutomation() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAutomation(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAutomation() {
      ::grpc::Service::MarkMethodRawCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAutomation(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAutomation() {
      ::grpc::Service::MarkMethodRawCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAutomation(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRequest* /*request*/, ::google::cloud::deploy::v1::Automation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutomation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAutomations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAutomations() {
      ::grpc::Service::MarkMethodRawCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAutomations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAutomations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomations(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAutomations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAutomationRun() {
      ::grpc::Service::MarkMethodRawCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAutomationRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::AutomationRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutomationRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAutomationRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAutomationRuns() {
      ::grpc::Service::MarkMethodRawCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAutomationRuns(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAutomationRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAutomationRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAutomationRuns(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelAutomationRun() {
      ::grpc::Service::MarkMethodRawCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelAutomationRun(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::CancelAutomationRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelAutomationRun(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDeliveryPipelines : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDeliveryPipelines() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* streamer) {
                       return this->StreamedListDeliveryPipelines(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDeliveryPipelines() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDeliveryPipelines(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest* /*request*/, ::google::cloud::deploy::v1::ListDeliveryPipelinesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDeliveryPipelines(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListDeliveryPipelinesRequest,::google::cloud::deploy::v1::ListDeliveryPipelinesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetDeliveryPipelineRequest, ::google::cloud::deploy::v1::DeliveryPipeline>* streamer) {
                       return this->StreamedGetDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetDeliveryPipelineRequest* /*request*/, ::google::cloud::deploy::v1::DeliveryPipeline* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetDeliveryPipelineRequest,::google::cloud::deploy::v1::DeliveryPipeline>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateDeliveryPipelineRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::UpdateDeliveryPipelineRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDeliveryPipeline : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDeliveryPipeline() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteDeliveryPipeline(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDeliveryPipeline() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDeliveryPipeline(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDeliveryPipeline(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::DeleteDeliveryPipelineRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTargets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTargets() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListTargetsRequest, ::google::cloud::deploy::v1::ListTargetsResponse>* streamer) {
                       return this->StreamedListTargets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTargets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTargets(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListTargetsRequest* /*request*/, ::google::cloud::deploy::v1::ListTargetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTargets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListTargetsRequest,::google::cloud::deploy::v1::ListTargetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RollbackTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RollbackTarget() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::RollbackTargetRequest, ::google::cloud::deploy::v1::RollbackTargetResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::RollbackTargetRequest, ::google::cloud::deploy::v1::RollbackTargetResponse>* streamer) {
                       return this->StreamedRollbackTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RollbackTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RollbackTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RollbackTargetRequest* /*request*/, ::google::cloud::deploy::v1::RollbackTargetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRollbackTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::RollbackTargetRequest,::google::cloud::deploy::v1::RollbackTargetResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTarget() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetTargetRequest, ::google::cloud::deploy::v1::Target>* streamer) {
                       return this->StreamedGetTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetTargetRequest* /*request*/, ::google::cloud::deploy::v1::Target* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetTargetRequest,::google::cloud::deploy::v1::Target>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTarget() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateTargetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateTargetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTarget() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::UpdateTargetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::UpdateTargetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTarget : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTarget() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::DeleteTargetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteTarget(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTarget() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTarget(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteTargetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTarget(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::DeleteTargetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCustomTargetTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCustomTargetTypes() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListCustomTargetTypesRequest, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListCustomTargetTypesRequest, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* streamer) {
                       return this->StreamedListCustomTargetTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCustomTargetTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCustomTargetTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListCustomTargetTypesRequest* /*request*/, ::google::cloud::deploy::v1::ListCustomTargetTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCustomTargetTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListCustomTargetTypesRequest,::google::cloud::deploy::v1::ListCustomTargetTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCustomTargetType() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetCustomTargetTypeRequest, ::google::cloud::deploy::v1::CustomTargetType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetCustomTargetTypeRequest, ::google::cloud::deploy::v1::CustomTargetType>* streamer) {
                       return this->StreamedGetCustomTargetType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetCustomTargetTypeRequest* /*request*/, ::google::cloud::deploy::v1::CustomTargetType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCustomTargetType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetCustomTargetTypeRequest,::google::cloud::deploy::v1::CustomTargetType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCustomTargetType() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCustomTargetType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCustomTargetType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateCustomTargetTypeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCustomTargetType() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCustomTargetType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCustomTargetType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::UpdateCustomTargetTypeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCustomTargetType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCustomTargetType() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCustomTargetType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCustomTargetType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCustomTargetType(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCustomTargetType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::DeleteCustomTargetTypeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListReleases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListReleases() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListReleasesRequest, ::google::cloud::deploy::v1::ListReleasesResponse>* streamer) {
                       return this->StreamedListReleases(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListReleases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListReleases(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListReleasesRequest* /*request*/, ::google::cloud::deploy::v1::ListReleasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListReleases(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListReleasesRequest,::google::cloud::deploy::v1::ListReleasesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRelease() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetReleaseRequest, ::google::cloud::deploy::v1::Release>* streamer) {
                       return this->StreamedGetRelease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetReleaseRequest* /*request*/, ::google::cloud::deploy::v1::Release* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRelease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetReleaseRequest,::google::cloud::deploy::v1::Release>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRelease() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateReleaseRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateRelease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateReleaseRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRelease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateReleaseRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AbandonRelease : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AbandonRelease() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::AbandonReleaseRequest, ::google::cloud::deploy::v1::AbandonReleaseResponse>* streamer) {
                       return this->StreamedAbandonRelease(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AbandonRelease() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AbandonRelease(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AbandonReleaseRequest* /*request*/, ::google::cloud::deploy::v1::AbandonReleaseResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAbandonRelease(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::AbandonReleaseRequest,::google::cloud::deploy::v1::AbandonReleaseResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApproveRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApproveRollout() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ApproveRolloutRequest, ::google::cloud::deploy::v1::ApproveRolloutResponse>* streamer) {
                       return this->StreamedApproveRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApproveRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApproveRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ApproveRolloutRequest* /*request*/, ::google::cloud::deploy::v1::ApproveRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApproveRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ApproveRolloutRequest,::google::cloud::deploy::v1::ApproveRolloutResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AdvanceRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AdvanceRollout() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::AdvanceRolloutRequest, ::google::cloud::deploy::v1::AdvanceRolloutResponse>* streamer) {
                       return this->StreamedAdvanceRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AdvanceRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AdvanceRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::AdvanceRolloutRequest* /*request*/, ::google::cloud::deploy::v1::AdvanceRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAdvanceRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::AdvanceRolloutRequest,::google::cloud::deploy::v1::AdvanceRolloutResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelRollout() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CancelRolloutRequest, ::google::cloud::deploy::v1::CancelRolloutResponse>* streamer) {
                       return this->StreamedCancelRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelRolloutRequest* /*request*/, ::google::cloud::deploy::v1::CancelRolloutResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CancelRolloutRequest,::google::cloud::deploy::v1::CancelRolloutResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRollouts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRollouts() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListRolloutsRequest, ::google::cloud::deploy::v1::ListRolloutsResponse>* streamer) {
                       return this->StreamedListRollouts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRollouts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRollouts(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListRolloutsRequest* /*request*/, ::google::cloud::deploy::v1::ListRolloutsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRollouts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListRolloutsRequest,::google::cloud::deploy::v1::ListRolloutsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRollout() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetRolloutRequest, ::google::cloud::deploy::v1::Rollout>* streamer) {
                       return this->StreamedGetRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetRolloutRequest* /*request*/, ::google::cloud::deploy::v1::Rollout* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetRolloutRequest,::google::cloud::deploy::v1::Rollout>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRollout : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRollout() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateRolloutRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateRollout(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRollout() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRollout(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateRolloutRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRollout(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateRolloutRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_IgnoreJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_IgnoreJob() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::IgnoreJobRequest, ::google::cloud::deploy::v1::IgnoreJobResponse>* streamer) {
                       return this->StreamedIgnoreJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_IgnoreJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status IgnoreJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::IgnoreJobRequest* /*request*/, ::google::cloud::deploy::v1::IgnoreJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedIgnoreJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::IgnoreJobRequest,::google::cloud::deploy::v1::IgnoreJobResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RetryJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RetryJob() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::RetryJobRequest, ::google::cloud::deploy::v1::RetryJobResponse>* streamer) {
                       return this->StreamedRetryJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RetryJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RetryJob(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::RetryJobRequest* /*request*/, ::google::cloud::deploy::v1::RetryJobResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRetryJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::RetryJobRequest,::google::cloud::deploy::v1::RetryJobResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobRuns() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListJobRunsRequest, ::google::cloud::deploy::v1::ListJobRunsResponse>* streamer) {
                       return this->StreamedListJobRuns(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListJobRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListJobRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobRuns(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListJobRunsRequest,::google::cloud::deploy::v1::ListJobRunsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJobRun() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetJobRunRequest, ::google::cloud::deploy::v1::JobRun>* streamer) {
                       return this->StreamedGetJobRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetJobRunRequest* /*request*/, ::google::cloud::deploy::v1::JobRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJobRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetJobRunRequest,::google::cloud::deploy::v1::JobRun>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TerminateJobRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TerminateJobRun() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::TerminateJobRunRequest, ::google::cloud::deploy::v1::TerminateJobRunResponse>* streamer) {
                       return this->StreamedTerminateJobRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TerminateJobRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TerminateJobRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::TerminateJobRunRequest* /*request*/, ::google::cloud::deploy::v1::TerminateJobRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTerminateJobRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::TerminateJobRunRequest,::google::cloud::deploy::v1::TerminateJobRunResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetConfig() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetConfigRequest, ::google::cloud::deploy::v1::Config>* streamer) {
                       return this->StreamedGetConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetConfigRequest* /*request*/, ::google::cloud::deploy::v1::Config* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetConfigRequest,::google::cloud::deploy::v1::Config>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAutomation() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CreateAutomationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CreateAutomationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAutomation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CreateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAutomation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CreateAutomationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAutomation() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::UpdateAutomationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::UpdateAutomationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateAutomation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::UpdateAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAutomation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::UpdateAutomationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAutomation() {
      ::grpc::Service::MarkMethodStreamed(34,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::DeleteAutomationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::DeleteAutomationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAutomation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::DeleteAutomationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAutomation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::DeleteAutomationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAutomation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAutomation() {
      ::grpc::Service::MarkMethodStreamed(35,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetAutomationRequest, ::google::cloud::deploy::v1::Automation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetAutomationRequest, ::google::cloud::deploy::v1::Automation>* streamer) {
                       return this->StreamedGetAutomation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAutomation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAutomation(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRequest* /*request*/, ::google::cloud::deploy::v1::Automation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAutomation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetAutomationRequest,::google::cloud::deploy::v1::Automation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAutomations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAutomations() {
      ::grpc::Service::MarkMethodStreamed(36,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListAutomationsRequest, ::google::cloud::deploy::v1::ListAutomationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListAutomationsRequest, ::google::cloud::deploy::v1::ListAutomationsResponse>* streamer) {
                       return this->StreamedListAutomations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAutomations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAutomations(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAutomations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListAutomationsRequest,::google::cloud::deploy::v1::ListAutomationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAutomationRun() {
      ::grpc::Service::MarkMethodStreamed(37,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::GetAutomationRunRequest, ::google::cloud::deploy::v1::AutomationRun>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::GetAutomationRunRequest, ::google::cloud::deploy::v1::AutomationRun>* streamer) {
                       return this->StreamedGetAutomationRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::GetAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::AutomationRun* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAutomationRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::GetAutomationRunRequest,::google::cloud::deploy::v1::AutomationRun>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAutomationRuns : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAutomationRuns() {
      ::grpc::Service::MarkMethodStreamed(38,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::ListAutomationRunsRequest, ::google::cloud::deploy::v1::ListAutomationRunsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::ListAutomationRunsRequest, ::google::cloud::deploy::v1::ListAutomationRunsResponse>* streamer) {
                       return this->StreamedListAutomationRuns(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAutomationRuns() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAutomationRuns(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::ListAutomationRunsRequest* /*request*/, ::google::cloud::deploy::v1::ListAutomationRunsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAutomationRuns(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::ListAutomationRunsRequest,::google::cloud::deploy::v1::ListAutomationRunsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelAutomationRun : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelAutomationRun() {
      ::grpc::Service::MarkMethodStreamed(39,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::deploy::v1::CancelAutomationRunRequest, ::google::cloud::deploy::v1::CancelAutomationRunResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::deploy::v1::CancelAutomationRunRequest, ::google::cloud::deploy::v1::CancelAutomationRunResponse>* streamer) {
                       return this->StreamedCancelAutomationRun(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelAutomationRun() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelAutomationRun(::grpc::ServerContext* /*context*/, const ::google::cloud::deploy::v1::CancelAutomationRunRequest* /*request*/, ::google::cloud::deploy::v1::CancelAutomationRunResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelAutomationRun(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::deploy::v1::CancelAutomationRunRequest,::google::cloud::deploy::v1::CancelAutomationRunResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListDeliveryPipelines<WithStreamedUnaryMethod_GetDeliveryPipeline<WithStreamedUnaryMethod_CreateDeliveryPipeline<WithStreamedUnaryMethod_UpdateDeliveryPipeline<WithStreamedUnaryMethod_DeleteDeliveryPipeline<WithStreamedUnaryMethod_ListTargets<WithStreamedUnaryMethod_RollbackTarget<WithStreamedUnaryMethod_GetTarget<WithStreamedUnaryMethod_CreateTarget<WithStreamedUnaryMethod_UpdateTarget<WithStreamedUnaryMethod_DeleteTarget<WithStreamedUnaryMethod_ListCustomTargetTypes<WithStreamedUnaryMethod_GetCustomTargetType<WithStreamedUnaryMethod_CreateCustomTargetType<WithStreamedUnaryMethod_UpdateCustomTargetType<WithStreamedUnaryMethod_DeleteCustomTargetType<WithStreamedUnaryMethod_ListReleases<WithStreamedUnaryMethod_GetRelease<WithStreamedUnaryMethod_CreateRelease<WithStreamedUnaryMethod_AbandonRelease<WithStreamedUnaryMethod_ApproveRollout<WithStreamedUnaryMethod_AdvanceRollout<WithStreamedUnaryMethod_CancelRollout<WithStreamedUnaryMethod_ListRollouts<WithStreamedUnaryMethod_GetRollout<WithStreamedUnaryMethod_CreateRollout<WithStreamedUnaryMethod_IgnoreJob<WithStreamedUnaryMethod_RetryJob<WithStreamedUnaryMethod_ListJobRuns<WithStreamedUnaryMethod_GetJobRun<WithStreamedUnaryMethod_TerminateJobRun<WithStreamedUnaryMethod_GetConfig<WithStreamedUnaryMethod_CreateAutomation<WithStreamedUnaryMethod_UpdateAutomation<WithStreamedUnaryMethod_DeleteAutomation<WithStreamedUnaryMethod_GetAutomation<WithStreamedUnaryMethod_ListAutomations<WithStreamedUnaryMethod_GetAutomationRun<WithStreamedUnaryMethod_ListAutomationRuns<WithStreamedUnaryMethod_CancelAutomationRun<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListDeliveryPipelines<WithStreamedUnaryMethod_GetDeliveryPipeline<WithStreamedUnaryMethod_CreateDeliveryPipeline<WithStreamedUnaryMethod_UpdateDeliveryPipeline<WithStreamedUnaryMethod_DeleteDeliveryPipeline<WithStreamedUnaryMethod_ListTargets<WithStreamedUnaryMethod_RollbackTarget<WithStreamedUnaryMethod_GetTarget<WithStreamedUnaryMethod_CreateTarget<WithStreamedUnaryMethod_UpdateTarget<WithStreamedUnaryMethod_DeleteTarget<WithStreamedUnaryMethod_ListCustomTargetTypes<WithStreamedUnaryMethod_GetCustomTargetType<WithStreamedUnaryMethod_CreateCustomTargetType<WithStreamedUnaryMethod_UpdateCustomTargetType<WithStreamedUnaryMethod_DeleteCustomTargetType<WithStreamedUnaryMethod_ListReleases<WithStreamedUnaryMethod_GetRelease<WithStreamedUnaryMethod_CreateRelease<WithStreamedUnaryMethod_AbandonRelease<WithStreamedUnaryMethod_ApproveRollout<WithStreamedUnaryMethod_AdvanceRollout<WithStreamedUnaryMethod_CancelRollout<WithStreamedUnaryMethod_ListRollouts<WithStreamedUnaryMethod_GetRollout<WithStreamedUnaryMethod_CreateRollout<WithStreamedUnaryMethod_IgnoreJob<WithStreamedUnaryMethod_RetryJob<WithStreamedUnaryMethod_ListJobRuns<WithStreamedUnaryMethod_GetJobRun<WithStreamedUnaryMethod_TerminateJobRun<WithStreamedUnaryMethod_GetConfig<WithStreamedUnaryMethod_CreateAutomation<WithStreamedUnaryMethod_UpdateAutomation<WithStreamedUnaryMethod_DeleteAutomation<WithStreamedUnaryMethod_GetAutomation<WithStreamedUnaryMethod_ListAutomations<WithStreamedUnaryMethod_GetAutomationRun<WithStreamedUnaryMethod_ListAutomationRuns<WithStreamedUnaryMethod_CancelAutomationRun<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace deploy
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdeploy_2fv1_2fcloud_5fdeploy_2eproto__INCLUDED
