// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/documentai/v1/document_processor_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdocumentai_2fv1_2fdocument_5fprocessor_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdocumentai_2fv1_2fdocument_5fprocessor_5fservice_2eproto__INCLUDED

#include "google/cloud/documentai/v1/document_processor_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace documentai {
namespace v1 {

// Service to call Document AI to process documents according to the
// processor's definition. Processors are built using state-of-the-art Google
// AI such as natural language, computer vision, and translation to extract
// structured information from unstructured or semi-structured documents.
class DocumentProcessorService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.documentai.v1.DocumentProcessorService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Processes a single document.
    virtual ::grpc::Status ProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::google::cloud::documentai::v1::ProcessResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessResponse>> AsyncProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessResponse>>(AsyncProcessDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessResponse>> PrepareAsyncProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessResponse>>(PrepareAsyncProcessDocumentRaw(context, request, cq));
    }
    // LRO endpoint to batch process many documents. The output is written
    // to Cloud Storage as JSON in the [Document] format.
    virtual ::grpc::Status BatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchProcessDocumentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchProcessDocumentsRaw(context, request, cq));
    }
    // Fetches processor types. Note that we don't use
    // [ListProcessorTypes][google.cloud.documentai.v1.DocumentProcessorService.ListProcessorTypes]
    // here, because it isn't paginated.
    virtual ::grpc::Status FetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>> AsyncFetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>>(AsyncFetchProcessorTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>> PrepareAsyncFetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>>(PrepareAsyncFetchProcessorTypesRaw(context, request, cq));
    }
    // Lists the processor types that exist.
    virtual ::grpc::Status ListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorTypesResponse>> AsyncListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorTypesResponse>>(AsyncListProcessorTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorTypesResponse>> PrepareAsyncListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorTypesResponse>>(PrepareAsyncListProcessorTypesRaw(context, request, cq));
    }
    // Gets a processor type detail.
    virtual ::grpc::Status GetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::google::cloud::documentai::v1::ProcessorType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorType>> AsyncGetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorType>>(AsyncGetProcessorTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorType>> PrepareAsyncGetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorType>>(PrepareAsyncGetProcessorTypeRaw(context, request, cq));
    }
    // Lists all processors which belong to this project.
    virtual ::grpc::Status ListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::google::cloud::documentai::v1::ListProcessorsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorsResponse>> AsyncListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorsResponse>>(AsyncListProcessorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorsResponse>> PrepareAsyncListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorsResponse>>(PrepareAsyncListProcessorsRaw(context, request, cq));
    }
    // Gets a processor detail.
    virtual ::grpc::Status GetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::google::cloud::documentai::v1::Processor* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>> AsyncGetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>>(AsyncGetProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>> PrepareAsyncGetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>>(PrepareAsyncGetProcessorRaw(context, request, cq));
    }
    // Trains a new processor version.
    // Operation metadata is returned as
    // [TrainProcessorVersionMetadata][google.cloud.documentai.v1.TrainProcessorVersionMetadata].
    virtual ::grpc::Status TrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncTrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncTrainProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncTrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncTrainProcessorVersionRaw(context, request, cq));
    }
    // Gets a processor version detail.
    virtual ::grpc::Status GetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::google::cloud::documentai::v1::ProcessorVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorVersion>> AsyncGetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorVersion>>(AsyncGetProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorVersion>> PrepareAsyncGetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorVersion>>(PrepareAsyncGetProcessorVersionRaw(context, request, cq));
    }
    // Lists all versions of a processor.
    virtual ::grpc::Status ListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>> AsyncListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>>(AsyncListProcessorVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>> PrepareAsyncListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>>(PrepareAsyncListProcessorVersionsRaw(context, request, cq));
    }
    // Deletes the processor version, all artifacts under the processor version
    // will be deleted.
    virtual ::grpc::Status DeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteProcessorVersionRaw(context, request, cq));
    }
    // Deploys the processor version.
    virtual ::grpc::Status DeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeployProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeployProcessorVersionRaw(context, request, cq));
    }
    // Undeploys the processor version.
    virtual ::grpc::Status UndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeployProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeployProcessorVersionRaw(context, request, cq));
    }
    // Creates a processor from the
    // [ProcessorType][google.cloud.documentai.v1.ProcessorType] provided. The
    // processor will be at `ENABLED` state by default after its creation. Note
    // that this method requires the `documentai.processors.create` permission on
    // the project, which is highly privileged. A user or service account with
    // this permission can create new processors that can interact with any gcs
    // bucket in your project.
    virtual ::grpc::Status CreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::google::cloud::documentai::v1::Processor* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>> AsyncCreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>>(AsyncCreateProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>> PrepareAsyncCreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>>(PrepareAsyncCreateProcessorRaw(context, request, cq));
    }
    // Deletes the processor, unloads all deployed model artifacts if it was
    // enabled and then deletes all artifacts associated with this processor.
    virtual ::grpc::Status DeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteProcessorRaw(context, request, cq));
    }
    // Enables a processor
    virtual ::grpc::Status EnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncEnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncEnableProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncEnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncEnableProcessorRaw(context, request, cq));
    }
    // Disables a processor
    virtual ::grpc::Status DisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDisableProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDisableProcessorRaw(context, request, cq));
    }
    // Set the default (active) version of a
    // [Processor][google.cloud.documentai.v1.Processor] that will be used in
    // [ProcessDocument][google.cloud.documentai.v1.DocumentProcessorService.ProcessDocument]
    // and
    // [BatchProcessDocuments][google.cloud.documentai.v1.DocumentProcessorService.BatchProcessDocuments].
    virtual ::grpc::Status SetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSetDefaultProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSetDefaultProcessorVersionRaw(context, request, cq));
    }
    // Send a document for Human Review. The input document should be processed by
    // the specified processor.
    virtual ::grpc::Status ReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncReviewDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncReviewDocumentRaw(context, request, cq));
    }
    // Evaluates a ProcessorVersion against annotated documents, producing an
    // Evaluation.
    virtual ::grpc::Status EvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncEvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncEvaluateProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncEvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncEvaluateProcessorVersionRaw(context, request, cq));
    }
    // Retrieves a specific evaluation.
    virtual ::grpc::Status GetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::google::cloud::documentai::v1::Evaluation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Evaluation>> AsyncGetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Evaluation>>(AsyncGetEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Evaluation>> PrepareAsyncGetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Evaluation>>(PrepareAsyncGetEvaluationRaw(context, request, cq));
    }
    // Retrieves a set of evaluations for a given processor version.
    virtual ::grpc::Status ListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListEvaluationsResponse>> AsyncListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListEvaluationsResponse>>(AsyncListEvaluationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListEvaluationsResponse>> PrepareAsyncListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListEvaluationsResponse>>(PrepareAsyncListEvaluationsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Processes a single document.
      virtual void ProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest* request, ::google::cloud::documentai::v1::ProcessResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest* request, ::google::cloud::documentai::v1::ProcessResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // LRO endpoint to batch process many documents. The output is written
      // to Cloud Storage as JSON in the [Document] format.
      virtual void BatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Fetches processor types. Note that we don't use
      // [ListProcessorTypes][google.cloud.documentai.v1.DocumentProcessorService.ListProcessorTypes]
      // here, because it isn't paginated.
      virtual void FetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the processor types that exist.
      virtual void ListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a processor type detail.
      virtual void GetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* request, ::google::cloud::documentai::v1::ProcessorType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* request, ::google::cloud::documentai::v1::ProcessorType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all processors which belong to this project.
      virtual void ListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest* request, ::google::cloud::documentai::v1::ListProcessorsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest* request, ::google::cloud::documentai::v1::ListProcessorsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a processor detail.
      virtual void GetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Trains a new processor version.
      // Operation metadata is returned as
      // [TrainProcessorVersionMetadata][google.cloud.documentai.v1.TrainProcessorVersionMetadata].
      virtual void TrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a processor version detail.
      virtual void GetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* request, ::google::cloud::documentai::v1::ProcessorVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* request, ::google::cloud::documentai::v1::ProcessorVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all versions of a processor.
      virtual void ListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the processor version, all artifacts under the processor version
      // will be deleted.
      virtual void DeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deploys the processor version.
      virtual void DeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Undeploys the processor version.
      virtual void UndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a processor from the
      // [ProcessorType][google.cloud.documentai.v1.ProcessorType] provided. The
      // processor will be at `ENABLED` state by default after its creation. Note
      // that this method requires the `documentai.processors.create` permission on
      // the project, which is highly privileged. A user or service account with
      // this permission can create new processors that can interact with any gcs
      // bucket in your project.
      virtual void CreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the processor, unloads all deployed model artifacts if it was
      // enabled and then deletes all artifacts associated with this processor.
      virtual void DeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Enables a processor
      virtual void EnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void EnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Disables a processor
      virtual void DisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Set the default (active) version of a
      // [Processor][google.cloud.documentai.v1.Processor] that will be used in
      // [ProcessDocument][google.cloud.documentai.v1.DocumentProcessorService.ProcessDocument]
      // and
      // [BatchProcessDocuments][google.cloud.documentai.v1.DocumentProcessorService.BatchProcessDocuments].
      virtual void SetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Send a document for Human Review. The input document should be processed by
      // the specified processor.
      virtual void ReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Evaluates a ProcessorVersion against annotated documents, producing an
      // Evaluation.
      virtual void EvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void EvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a specific evaluation.
      virtual void GetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest* request, ::google::cloud::documentai::v1::Evaluation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest* request, ::google::cloud::documentai::v1::Evaluation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a set of evaluations for a given processor version.
      virtual void ListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest* request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest* request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessResponse>* AsyncProcessDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessResponse>* PrepareAsyncProcessDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchProcessDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchProcessDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>* AsyncFetchProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>* PrepareAsyncFetchProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorTypesResponse>* AsyncListProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorTypesResponse>* PrepareAsyncListProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorType>* AsyncGetProcessorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorType>* PrepareAsyncGetProcessorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorsResponse>* AsyncListProcessorsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorsResponse>* PrepareAsyncListProcessorsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>* AsyncGetProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>* PrepareAsyncGetProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncTrainProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncTrainProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorVersion>* AsyncGetProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ProcessorVersion>* PrepareAsyncGetProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>* AsyncListProcessorVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>* PrepareAsyncListProcessorVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>* AsyncCreateProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Processor>* PrepareAsyncCreateProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncEnableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncEnableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDisableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDisableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSetDefaultProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSetDefaultProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncReviewDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncReviewDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncEvaluateProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncEvaluateProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Evaluation>* AsyncGetEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::Evaluation>* PrepareAsyncGetEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListEvaluationsResponse>* AsyncListEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::documentai::v1::ListEvaluationsResponse>* PrepareAsyncListEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::google::cloud::documentai::v1::ProcessResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessResponse>> AsyncProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessResponse>>(AsyncProcessDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessResponse>> PrepareAsyncProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessResponse>>(PrepareAsyncProcessDocumentRaw(context, request, cq));
    }
    ::grpc::Status BatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchProcessDocumentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchProcessDocumentsRaw(context, request, cq));
    }
    ::grpc::Status FetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>> AsyncFetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>>(AsyncFetchProcessorTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>> PrepareAsyncFetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>>(PrepareAsyncFetchProcessorTypesRaw(context, request, cq));
    }
    ::grpc::Status ListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorTypesResponse>> AsyncListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorTypesResponse>>(AsyncListProcessorTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorTypesResponse>> PrepareAsyncListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorTypesResponse>>(PrepareAsyncListProcessorTypesRaw(context, request, cq));
    }
    ::grpc::Status GetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::google::cloud::documentai::v1::ProcessorType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorType>> AsyncGetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorType>>(AsyncGetProcessorTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorType>> PrepareAsyncGetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorType>>(PrepareAsyncGetProcessorTypeRaw(context, request, cq));
    }
    ::grpc::Status ListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::google::cloud::documentai::v1::ListProcessorsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorsResponse>> AsyncListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorsResponse>>(AsyncListProcessorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorsResponse>> PrepareAsyncListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorsResponse>>(PrepareAsyncListProcessorsRaw(context, request, cq));
    }
    ::grpc::Status GetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::google::cloud::documentai::v1::Processor* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>> AsyncGetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>>(AsyncGetProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>> PrepareAsyncGetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>>(PrepareAsyncGetProcessorRaw(context, request, cq));
    }
    ::grpc::Status TrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncTrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncTrainProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncTrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncTrainProcessorVersionRaw(context, request, cq));
    }
    ::grpc::Status GetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::google::cloud::documentai::v1::ProcessorVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorVersion>> AsyncGetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorVersion>>(AsyncGetProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorVersion>> PrepareAsyncGetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorVersion>>(PrepareAsyncGetProcessorVersionRaw(context, request, cq));
    }
    ::grpc::Status ListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>> AsyncListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>>(AsyncListProcessorVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>> PrepareAsyncListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>>(PrepareAsyncListProcessorVersionsRaw(context, request, cq));
    }
    ::grpc::Status DeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteProcessorVersionRaw(context, request, cq));
    }
    ::grpc::Status DeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeployProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeployProcessorVersionRaw(context, request, cq));
    }
    ::grpc::Status UndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeployProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeployProcessorVersionRaw(context, request, cq));
    }
    ::grpc::Status CreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::google::cloud::documentai::v1::Processor* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>> AsyncCreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>>(AsyncCreateProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>> PrepareAsyncCreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>>(PrepareAsyncCreateProcessorRaw(context, request, cq));
    }
    ::grpc::Status DeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteProcessorRaw(context, request, cq));
    }
    ::grpc::Status EnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncEnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncEnableProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncEnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncEnableProcessorRaw(context, request, cq));
    }
    ::grpc::Status DisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDisableProcessorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDisableProcessorRaw(context, request, cq));
    }
    ::grpc::Status SetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSetDefaultProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSetDefaultProcessorVersionRaw(context, request, cq));
    }
    ::grpc::Status ReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncReviewDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncReviewDocumentRaw(context, request, cq));
    }
    ::grpc::Status EvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncEvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncEvaluateProcessorVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncEvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncEvaluateProcessorVersionRaw(context, request, cq));
    }
    ::grpc::Status GetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::google::cloud::documentai::v1::Evaluation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Evaluation>> AsyncGetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Evaluation>>(AsyncGetEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Evaluation>> PrepareAsyncGetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Evaluation>>(PrepareAsyncGetEvaluationRaw(context, request, cq));
    }
    ::grpc::Status ListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListEvaluationsResponse>> AsyncListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListEvaluationsResponse>>(AsyncListEvaluationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListEvaluationsResponse>> PrepareAsyncListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListEvaluationsResponse>>(PrepareAsyncListEvaluationsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest* request, ::google::cloud::documentai::v1::ProcessResponse* response, std::function<void(::grpc::Status)>) override;
      void ProcessDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest* request, ::google::cloud::documentai::v1::ProcessResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchProcessDocuments(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void FetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void FetchProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProcessorTypes(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* request, ::google::cloud::documentai::v1::ProcessorType* response, std::function<void(::grpc::Status)>) override;
      void GetProcessorType(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* request, ::google::cloud::documentai::v1::ProcessorType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest* request, ::google::cloud::documentai::v1::ListProcessorsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProcessors(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest* request, ::google::cloud::documentai::v1::ListProcessorsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, std::function<void(::grpc::Status)>) override;
      void GetProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TrainProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* request, ::google::cloud::documentai::v1::ProcessorVersion* response, std::function<void(::grpc::Status)>) override;
      void GetProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* request, ::google::cloud::documentai::v1::ProcessorVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProcessorVersions(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeployProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, std::function<void(::grpc::Status)>) override;
      void CreateProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void EnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void EnableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DisableProcessor(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SetDefaultProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ReviewDocument(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void EvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void EvaluateProcessorVersion(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest* request, ::google::cloud::documentai::v1::Evaluation* response, std::function<void(::grpc::Status)>) override;
      void GetEvaluation(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest* request, ::google::cloud::documentai::v1::Evaluation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest* request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEvaluations(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest* request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessResponse>* AsyncProcessDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessResponse>* PrepareAsyncProcessDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchProcessDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchProcessDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>* AsyncFetchProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>* PrepareAsyncFetchProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorTypesResponse>* AsyncListProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorTypesResponse>* PrepareAsyncListProcessorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorType>* AsyncGetProcessorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorType>* PrepareAsyncGetProcessorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorsResponse>* AsyncListProcessorsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorsResponse>* PrepareAsyncListProcessorsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>* AsyncGetProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>* PrepareAsyncGetProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncTrainProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncTrainProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorVersion>* AsyncGetProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ProcessorVersion>* PrepareAsyncGetProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>* AsyncListProcessorVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>* PrepareAsyncListProcessorVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeployProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>* AsyncCreateProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Processor>* PrepareAsyncCreateProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncEnableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncEnableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDisableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDisableProcessorRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSetDefaultProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSetDefaultProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncReviewDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncReviewDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncEvaluateProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncEvaluateProcessorVersionRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Evaluation>* AsyncGetEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::Evaluation>* PrepareAsyncGetEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListEvaluationsResponse>* AsyncListEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::documentai::v1::ListEvaluationsResponse>* PrepareAsyncListEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ProcessDocument_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchProcessDocuments_;
    const ::grpc::internal::RpcMethod rpcmethod_FetchProcessorTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProcessorTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProcessorType_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProcessors_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProcessor_;
    const ::grpc::internal::RpcMethod rpcmethod_TrainProcessorVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProcessorVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProcessorVersions_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteProcessorVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_DeployProcessorVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeployProcessorVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateProcessor_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteProcessor_;
    const ::grpc::internal::RpcMethod rpcmethod_EnableProcessor_;
    const ::grpc::internal::RpcMethod rpcmethod_DisableProcessor_;
    const ::grpc::internal::RpcMethod rpcmethod_SetDefaultProcessorVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_ReviewDocument_;
    const ::grpc::internal::RpcMethod rpcmethod_EvaluateProcessorVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEvaluation_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEvaluations_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Processes a single document.
    virtual ::grpc::Status ProcessDocument(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::ProcessRequest* request, ::google::cloud::documentai::v1::ProcessResponse* response);
    // LRO endpoint to batch process many documents. The output is written
    // to Cloud Storage as JSON in the [Document] format.
    virtual ::grpc::Status BatchProcessDocuments(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest* request, ::google::longrunning::Operation* response);
    // Fetches processor types. Note that we don't use
    // [ListProcessorTypes][google.cloud.documentai.v1.DocumentProcessorService.ListProcessorTypes]
    // here, because it isn't paginated.
    virtual ::grpc::Status FetchProcessorTypes(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response);
    // Lists the processor types that exist.
    virtual ::grpc::Status ListProcessorTypes(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response);
    // Gets a processor type detail.
    virtual ::grpc::Status GetProcessorType(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* request, ::google::cloud::documentai::v1::ProcessorType* response);
    // Lists all processors which belong to this project.
    virtual ::grpc::Status ListProcessors(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest* request, ::google::cloud::documentai::v1::ListProcessorsResponse* response);
    // Gets a processor detail.
    virtual ::grpc::Status GetProcessor(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response);
    // Trains a new processor version.
    // Operation metadata is returned as
    // [TrainProcessorVersionMetadata][google.cloud.documentai.v1.TrainProcessorVersionMetadata].
    virtual ::grpc::Status TrainProcessorVersion(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* request, ::google::longrunning::Operation* response);
    // Gets a processor version detail.
    virtual ::grpc::Status GetProcessorVersion(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* request, ::google::cloud::documentai::v1::ProcessorVersion* response);
    // Lists all versions of a processor.
    virtual ::grpc::Status ListProcessorVersions(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response);
    // Deletes the processor version, all artifacts under the processor version
    // will be deleted.
    virtual ::grpc::Status DeleteProcessorVersion(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* request, ::google::longrunning::Operation* response);
    // Deploys the processor version.
    virtual ::grpc::Status DeployProcessorVersion(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* request, ::google::longrunning::Operation* response);
    // Undeploys the processor version.
    virtual ::grpc::Status UndeployProcessorVersion(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* request, ::google::longrunning::Operation* response);
    // Creates a processor from the
    // [ProcessorType][google.cloud.documentai.v1.ProcessorType] provided. The
    // processor will be at `ENABLED` state by default after its creation. Note
    // that this method requires the `documentai.processors.create` permission on
    // the project, which is highly privileged. A user or service account with
    // this permission can create new processors that can interact with any gcs
    // bucket in your project.
    virtual ::grpc::Status CreateProcessor(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response);
    // Deletes the processor, unloads all deployed model artifacts if it was
    // enabled and then deletes all artifacts associated with this processor.
    virtual ::grpc::Status DeleteProcessor(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest* request, ::google::longrunning::Operation* response);
    // Enables a processor
    virtual ::grpc::Status EnableProcessor(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest* request, ::google::longrunning::Operation* response);
    // Disables a processor
    virtual ::grpc::Status DisableProcessor(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest* request, ::google::longrunning::Operation* response);
    // Set the default (active) version of a
    // [Processor][google.cloud.documentai.v1.Processor] that will be used in
    // [ProcessDocument][google.cloud.documentai.v1.DocumentProcessorService.ProcessDocument]
    // and
    // [BatchProcessDocuments][google.cloud.documentai.v1.DocumentProcessorService.BatchProcessDocuments].
    virtual ::grpc::Status SetDefaultProcessorVersion(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* request, ::google::longrunning::Operation* response);
    // Send a document for Human Review. The input document should be processed by
    // the specified processor.
    virtual ::grpc::Status ReviewDocument(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest* request, ::google::longrunning::Operation* response);
    // Evaluates a ProcessorVersion against annotated documents, producing an
    // Evaluation.
    virtual ::grpc::Status EvaluateProcessorVersion(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* request, ::google::longrunning::Operation* response);
    // Retrieves a specific evaluation.
    virtual ::grpc::Status GetEvaluation(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest* request, ::google::cloud::documentai::v1::Evaluation* response);
    // Retrieves a set of evaluations for a given processor version.
    virtual ::grpc::Status ListEvaluations(::grpc::ServerContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest* request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ProcessDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ProcessDocument() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ProcessDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ProcessRequest* /*request*/, ::google::cloud::documentai::v1::ProcessResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProcessDocument(::grpc::ServerContext* context, ::google::cloud::documentai::v1::ProcessRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::ProcessResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchProcessDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchProcessDocuments() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_BatchProcessDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchProcessDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::BatchProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchProcessDocuments(::grpc::ServerContext* context, ::google::cloud::documentai::v1::BatchProcessRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_FetchProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FetchProcessorTypes() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_FetchProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchProcessorTypes(::grpc::ServerContext* context, ::google::cloud::documentai::v1::FetchProcessorTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::FetchProcessorTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProcessorTypes() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcessorTypes(::grpc::ServerContext* context, ::google::cloud::documentai::v1::ListProcessorTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::ListProcessorTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProcessorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProcessorType() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetProcessorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorType(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcessorType(::grpc::ServerContext* context, ::google::cloud::documentai::v1::GetProcessorTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::ProcessorType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProcessors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProcessors() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListProcessors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessors(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcessors(::grpc::ServerContext* context, ::google::cloud::documentai::v1::ListProcessorsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::ListProcessorsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProcessor() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcessor(::grpc::ServerContext* context, ::google::cloud::documentai::v1::GetProcessorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::Processor>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TrainProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TrainProcessorVersion() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_TrainProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTrainProcessorVersion(::grpc::ServerContext* context, ::google::cloud::documentai::v1::TrainProcessorVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProcessorVersion() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcessorVersion(::grpc::ServerContext* context, ::google::cloud::documentai::v1::GetProcessorVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::ProcessorVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProcessorVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProcessorVersions() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListProcessorVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcessorVersions(::grpc::ServerContext* context, ::google::cloud::documentai::v1::ListProcessorVersionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::ListProcessorVersionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteProcessorVersion() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProcessorVersion(::grpc::ServerContext* context, ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeployProcessorVersion() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeployProcessorVersion(::grpc::ServerContext* context, ::google::cloud::documentai::v1::DeployProcessorVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeployProcessorVersion() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_UndeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeployProcessorVersion(::grpc::ServerContext* context, ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateProcessor() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_CreateProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::CreateProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProcessor(::grpc::ServerContext* context, ::google::cloud::documentai::v1::CreateProcessorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::Processor>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteProcessor() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProcessor(::grpc::ServerContext* context, ::google::cloud::documentai::v1::DeleteProcessorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_EnableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_EnableProcessor() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_EnableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EnableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEnableProcessor(::grpc::ServerContext* context, ::google::cloud::documentai::v1::EnableProcessorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DisableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DisableProcessor() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_DisableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DisableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDisableProcessor(::grpc::ServerContext* context, ::google::cloud::documentai::v1::DisableProcessorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetDefaultProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetDefaultProcessorVersion() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_SetDefaultProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetDefaultProcessorVersion(::grpc::ServerContext* context, ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReviewDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReviewDocument() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_ReviewDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReviewDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ReviewDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReviewDocument(::grpc::ServerContext* context, ::google::cloud::documentai::v1::ReviewDocumentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_EvaluateProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_EvaluateProcessorVersion() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_EvaluateProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EvaluateProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEvaluateProcessorVersion(::grpc::ServerContext* context, ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEvaluation() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_GetEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetEvaluationRequest* /*request*/, ::google::cloud::documentai::v1::Evaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEvaluation(::grpc::ServerContext* context, ::google::cloud::documentai::v1::GetEvaluationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::Evaluation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEvaluations() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_ListEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListEvaluationsRequest* /*request*/, ::google::cloud::documentai::v1::ListEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEvaluations(::grpc::ServerContext* context, ::google::cloud::documentai::v1::ListEvaluationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::documentai::v1::ListEvaluationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ProcessDocument<WithAsyncMethod_BatchProcessDocuments<WithAsyncMethod_FetchProcessorTypes<WithAsyncMethod_ListProcessorTypes<WithAsyncMethod_GetProcessorType<WithAsyncMethod_ListProcessors<WithAsyncMethod_GetProcessor<WithAsyncMethod_TrainProcessorVersion<WithAsyncMethod_GetProcessorVersion<WithAsyncMethod_ListProcessorVersions<WithAsyncMethod_DeleteProcessorVersion<WithAsyncMethod_DeployProcessorVersion<WithAsyncMethod_UndeployProcessorVersion<WithAsyncMethod_CreateProcessor<WithAsyncMethod_DeleteProcessor<WithAsyncMethod_EnableProcessor<WithAsyncMethod_DisableProcessor<WithAsyncMethod_SetDefaultProcessorVersion<WithAsyncMethod_ReviewDocument<WithAsyncMethod_EvaluateProcessorVersion<WithAsyncMethod_GetEvaluation<WithAsyncMethod_ListEvaluations<Service > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ProcessDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ProcessDocument() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ProcessRequest, ::google::cloud::documentai::v1::ProcessResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::ProcessRequest* request, ::google::cloud::documentai::v1::ProcessResponse* response) { return this->ProcessDocument(context, request, response); }));}
    void SetMessageAllocatorFor_ProcessDocument(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::ProcessRequest, ::google::cloud::documentai::v1::ProcessResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ProcessRequest, ::google::cloud::documentai::v1::ProcessResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ProcessDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ProcessRequest* /*request*/, ::google::cloud::documentai::v1::ProcessResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProcessDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::ProcessRequest* /*request*/, ::google::cloud::documentai::v1::ProcessResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchProcessDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchProcessDocuments() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::BatchProcessRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::BatchProcessRequest* request, ::google::longrunning::Operation* response) { return this->BatchProcessDocuments(context, request, response); }));}
    void SetMessageAllocatorFor_BatchProcessDocuments(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::BatchProcessRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::BatchProcessRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchProcessDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchProcessDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::BatchProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchProcessDocuments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::BatchProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_FetchProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FetchProcessorTypes() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::FetchProcessorTypesRequest, ::google::cloud::documentai::v1::FetchProcessorTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* request, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* response) { return this->FetchProcessorTypes(context, request, response); }));}
    void SetMessageAllocatorFor_FetchProcessorTypes(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::FetchProcessorTypesRequest, ::google::cloud::documentai::v1::FetchProcessorTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::FetchProcessorTypesRequest, ::google::cloud::documentai::v1::FetchProcessorTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FetchProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchProcessorTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProcessorTypes() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListProcessorTypesRequest, ::google::cloud::documentai::v1::ListProcessorTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* request, ::google::cloud::documentai::v1::ListProcessorTypesResponse* response) { return this->ListProcessorTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListProcessorTypes(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::ListProcessorTypesRequest, ::google::cloud::documentai::v1::ListProcessorTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListProcessorTypesRequest, ::google::cloud::documentai::v1::ListProcessorTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcessorTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProcessorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProcessorType() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetProcessorTypeRequest, ::google::cloud::documentai::v1::ProcessorType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* request, ::google::cloud::documentai::v1::ProcessorType* response) { return this->GetProcessorType(context, request, response); }));}
    void SetMessageAllocatorFor_GetProcessorType(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::GetProcessorTypeRequest, ::google::cloud::documentai::v1::ProcessorType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetProcessorTypeRequest, ::google::cloud::documentai::v1::ProcessorType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProcessorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorType(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcessorType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProcessors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProcessors() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListProcessorsRequest, ::google::cloud::documentai::v1::ListProcessorsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::ListProcessorsRequest* request, ::google::cloud::documentai::v1::ListProcessorsResponse* response) { return this->ListProcessors(context, request, response); }));}
    void SetMessageAllocatorFor_ListProcessors(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::ListProcessorsRequest, ::google::cloud::documentai::v1::ListProcessorsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListProcessorsRequest, ::google::cloud::documentai::v1::ListProcessorsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProcessors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessors(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcessors(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProcessor() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetProcessorRequest, ::google::cloud::documentai::v1::Processor>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::GetProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response) { return this->GetProcessor(context, request, response); }));}
    void SetMessageAllocatorFor_GetProcessor(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::GetProcessorRequest, ::google::cloud::documentai::v1::Processor>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetProcessorRequest, ::google::cloud::documentai::v1::Processor>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TrainProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TrainProcessorVersion() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::TrainProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* request, ::google::longrunning::Operation* response) { return this->TrainProcessorVersion(context, request, response); }));}
    void SetMessageAllocatorFor_TrainProcessorVersion(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::TrainProcessorVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::TrainProcessorVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TrainProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TrainProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProcessorVersion() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetProcessorVersionRequest, ::google::cloud::documentai::v1::ProcessorVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* request, ::google::cloud::documentai::v1::ProcessorVersion* response) { return this->GetProcessorVersion(context, request, response); }));}
    void SetMessageAllocatorFor_GetProcessorVersion(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::GetProcessorVersionRequest, ::google::cloud::documentai::v1::ProcessorVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetProcessorVersionRequest, ::google::cloud::documentai::v1::ProcessorVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProcessorVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProcessorVersions() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListProcessorVersionsRequest, ::google::cloud::documentai::v1::ListProcessorVersionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* request, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* response) { return this->ListProcessorVersions(context, request, response); }));}
    void SetMessageAllocatorFor_ListProcessorVersions(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::ListProcessorVersionsRequest, ::google::cloud::documentai::v1::ListProcessorVersionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListProcessorVersionsRequest, ::google::cloud::documentai::v1::ListProcessorVersionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProcessorVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcessorVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteProcessorVersion() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DeleteProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* request, ::google::longrunning::Operation* response) { return this->DeleteProcessorVersion(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteProcessorVersion(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::DeleteProcessorVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DeleteProcessorVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeployProcessorVersion() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DeployProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* request, ::google::longrunning::Operation* response) { return this->DeployProcessorVersion(context, request, response); }));}
    void SetMessageAllocatorFor_DeployProcessorVersion(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::DeployProcessorVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DeployProcessorVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeployProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeployProcessorVersion() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::UndeployProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* request, ::google::longrunning::Operation* response) { return this->UndeployProcessorVersion(context, request, response); }));}
    void SetMessageAllocatorFor_UndeployProcessorVersion(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::UndeployProcessorVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::UndeployProcessorVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeployProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateProcessor() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::CreateProcessorRequest, ::google::cloud::documentai::v1::Processor>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::CreateProcessorRequest* request, ::google::cloud::documentai::v1::Processor* response) { return this->CreateProcessor(context, request, response); }));}
    void SetMessageAllocatorFor_CreateProcessor(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::CreateProcessorRequest, ::google::cloud::documentai::v1::Processor>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::CreateProcessorRequest, ::google::cloud::documentai::v1::Processor>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::CreateProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::CreateProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteProcessor() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DeleteProcessorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::DeleteProcessorRequest* request, ::google::longrunning::Operation* response) { return this->DeleteProcessor(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteProcessor(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::DeleteProcessorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DeleteProcessorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_EnableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_EnableProcessor() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::EnableProcessorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::EnableProcessorRequest* request, ::google::longrunning::Operation* response) { return this->EnableProcessor(context, request, response); }));}
    void SetMessageAllocatorFor_EnableProcessor(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::EnableProcessorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::EnableProcessorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_EnableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EnableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EnableProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::EnableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DisableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DisableProcessor() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DisableProcessorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::DisableProcessorRequest* request, ::google::longrunning::Operation* response) { return this->DisableProcessor(context, request, response); }));}
    void SetMessageAllocatorFor_DisableProcessor(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::DisableProcessorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::DisableProcessorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DisableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DisableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DisableProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::DisableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetDefaultProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetDefaultProcessorVersion() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* request, ::google::longrunning::Operation* response) { return this->SetDefaultProcessorVersion(context, request, response); }));}
    void SetMessageAllocatorFor_SetDefaultProcessorVersion(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetDefaultProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetDefaultProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReviewDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReviewDocument() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ReviewDocumentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::ReviewDocumentRequest* request, ::google::longrunning::Operation* response) { return this->ReviewDocument(context, request, response); }));}
    void SetMessageAllocatorFor_ReviewDocument(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::ReviewDocumentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ReviewDocumentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReviewDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReviewDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ReviewDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReviewDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::ReviewDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_EvaluateProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_EvaluateProcessorVersion() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* request, ::google::longrunning::Operation* response) { return this->EvaluateProcessorVersion(context, request, response); }));}
    void SetMessageAllocatorFor_EvaluateProcessorVersion(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_EvaluateProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EvaluateProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EvaluateProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEvaluation() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetEvaluationRequest, ::google::cloud::documentai::v1::Evaluation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::GetEvaluationRequest* request, ::google::cloud::documentai::v1::Evaluation* response) { return this->GetEvaluation(context, request, response); }));}
    void SetMessageAllocatorFor_GetEvaluation(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::GetEvaluationRequest, ::google::cloud::documentai::v1::Evaluation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::GetEvaluationRequest, ::google::cloud::documentai::v1::Evaluation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetEvaluationRequest* /*request*/, ::google::cloud::documentai::v1::Evaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::GetEvaluationRequest* /*request*/, ::google::cloud::documentai::v1::Evaluation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEvaluations() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListEvaluationsRequest, ::google::cloud::documentai::v1::ListEvaluationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::documentai::v1::ListEvaluationsRequest* request, ::google::cloud::documentai::v1::ListEvaluationsResponse* response) { return this->ListEvaluations(context, request, response); }));}
    void SetMessageAllocatorFor_ListEvaluations(
        ::grpc::MessageAllocator< ::google::cloud::documentai::v1::ListEvaluationsRequest, ::google::cloud::documentai::v1::ListEvaluationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::documentai::v1::ListEvaluationsRequest, ::google::cloud::documentai::v1::ListEvaluationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListEvaluationsRequest* /*request*/, ::google::cloud::documentai::v1::ListEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEvaluations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::documentai::v1::ListEvaluationsRequest* /*request*/, ::google::cloud::documentai::v1::ListEvaluationsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ProcessDocument<WithCallbackMethod_BatchProcessDocuments<WithCallbackMethod_FetchProcessorTypes<WithCallbackMethod_ListProcessorTypes<WithCallbackMethod_GetProcessorType<WithCallbackMethod_ListProcessors<WithCallbackMethod_GetProcessor<WithCallbackMethod_TrainProcessorVersion<WithCallbackMethod_GetProcessorVersion<WithCallbackMethod_ListProcessorVersions<WithCallbackMethod_DeleteProcessorVersion<WithCallbackMethod_DeployProcessorVersion<WithCallbackMethod_UndeployProcessorVersion<WithCallbackMethod_CreateProcessor<WithCallbackMethod_DeleteProcessor<WithCallbackMethod_EnableProcessor<WithCallbackMethod_DisableProcessor<WithCallbackMethod_SetDefaultProcessorVersion<WithCallbackMethod_ReviewDocument<WithCallbackMethod_EvaluateProcessorVersion<WithCallbackMethod_GetEvaluation<WithCallbackMethod_ListEvaluations<Service > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ProcessDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ProcessDocument() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ProcessDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ProcessRequest* /*request*/, ::google::cloud::documentai::v1::ProcessResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchProcessDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchProcessDocuments() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_BatchProcessDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchProcessDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::BatchProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_FetchProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FetchProcessorTypes() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_FetchProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProcessorTypes() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProcessorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProcessorType() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetProcessorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorType(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProcessors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProcessors() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListProcessors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessors(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProcessor() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TrainProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TrainProcessorVersion() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_TrainProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProcessorVersion() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProcessorVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProcessorVersions() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListProcessorVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteProcessorVersion() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeployProcessorVersion() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeployProcessorVersion() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_UndeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateProcessor() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_CreateProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::CreateProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteProcessor() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_EnableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_EnableProcessor() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_EnableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EnableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DisableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DisableProcessor() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_DisableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DisableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetDefaultProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetDefaultProcessorVersion() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_SetDefaultProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReviewDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReviewDocument() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_ReviewDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReviewDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ReviewDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_EvaluateProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_EvaluateProcessorVersion() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_EvaluateProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EvaluateProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEvaluation() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_GetEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetEvaluationRequest* /*request*/, ::google::cloud::documentai::v1::Evaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEvaluations() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_ListEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListEvaluationsRequest* /*request*/, ::google::cloud::documentai::v1::ListEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ProcessDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ProcessDocument() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ProcessDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ProcessRequest* /*request*/, ::google::cloud::documentai::v1::ProcessResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProcessDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchProcessDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchProcessDocuments() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_BatchProcessDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchProcessDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::BatchProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchProcessDocuments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_FetchProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FetchProcessorTypes() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_FetchProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchProcessorTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProcessorTypes() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcessorTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProcessorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProcessorType() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetProcessorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorType(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcessorType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProcessors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProcessors() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListProcessors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessors(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcessors(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProcessor() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcessor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TrainProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TrainProcessorVersion() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_TrainProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTrainProcessorVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProcessorVersion() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProcessorVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProcessorVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProcessorVersions() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListProcessorVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProcessorVersions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteProcessorVersion() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProcessorVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeployProcessorVersion() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeployProcessorVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeployProcessorVersion() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_UndeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeployProcessorVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateProcessor() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_CreateProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::CreateProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProcessor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteProcessor() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProcessor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_EnableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_EnableProcessor() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_EnableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EnableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEnableProcessor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DisableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DisableProcessor() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_DisableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DisableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDisableProcessor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetDefaultProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetDefaultProcessorVersion() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_SetDefaultProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetDefaultProcessorVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReviewDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReviewDocument() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_ReviewDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReviewDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ReviewDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReviewDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_EvaluateProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_EvaluateProcessorVersion() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_EvaluateProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EvaluateProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEvaluateProcessorVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEvaluation() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_GetEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetEvaluationRequest* /*request*/, ::google::cloud::documentai::v1::Evaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEvaluation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEvaluations() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_ListEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListEvaluationsRequest* /*request*/, ::google::cloud::documentai::v1::ListEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEvaluations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ProcessDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ProcessDocument() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ProcessDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_ProcessDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProcessDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ProcessRequest* /*request*/, ::google::cloud::documentai::v1::ProcessResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProcessDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchProcessDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchProcessDocuments() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchProcessDocuments(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchProcessDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchProcessDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::BatchProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchProcessDocuments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FetchProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FetchProcessorTypes() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FetchProcessorTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_FetchProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchProcessorTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProcessorTypes() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProcessorTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcessorTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProcessorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProcessorType() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProcessorType(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProcessorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorType(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcessorType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProcessors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProcessors() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProcessors(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProcessors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessors(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcessors(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProcessor() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProcessor(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TrainProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TrainProcessorVersion() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TrainProcessorVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_TrainProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TrainProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProcessorVersion() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProcessorVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProcessorVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProcessorVersions() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProcessorVersions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProcessorVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProcessorVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProcessorVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteProcessorVersion() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteProcessorVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeployProcessorVersion() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeployProcessorVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeployProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeployProcessorVersion() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeployProcessorVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeployProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateProcessor() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateProcessor(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::CreateProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteProcessor() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteProcessor(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_EnableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_EnableProcessor() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->EnableProcessor(context, request, response); }));
    }
    ~WithRawCallbackMethod_EnableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EnableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EnableProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DisableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DisableProcessor() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DisableProcessor(context, request, response); }));
    }
    ~WithRawCallbackMethod_DisableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DisableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DisableProcessor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetDefaultProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetDefaultProcessorVersion() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetDefaultProcessorVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetDefaultProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetDefaultProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetDefaultProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReviewDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReviewDocument() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReviewDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReviewDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReviewDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ReviewDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReviewDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_EvaluateProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_EvaluateProcessorVersion() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->EvaluateProcessorVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_EvaluateProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EvaluateProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EvaluateProcessorVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEvaluation() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEvaluation(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetEvaluationRequest* /*request*/, ::google::cloud::documentai::v1::Evaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEvaluations() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEvaluations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListEvaluationsRequest* /*request*/, ::google::cloud::documentai::v1::ListEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEvaluations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ProcessDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ProcessDocument() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::ProcessRequest, ::google::cloud::documentai::v1::ProcessResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::ProcessRequest, ::google::cloud::documentai::v1::ProcessResponse>* streamer) {
                       return this->StreamedProcessDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ProcessDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ProcessDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ProcessRequest* /*request*/, ::google::cloud::documentai::v1::ProcessResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedProcessDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::ProcessRequest,::google::cloud::documentai::v1::ProcessResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchProcessDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchProcessDocuments() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::BatchProcessRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::BatchProcessRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchProcessDocuments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchProcessDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchProcessDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::BatchProcessRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchProcessDocuments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::BatchProcessRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FetchProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FetchProcessorTypes() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::FetchProcessorTypesRequest, ::google::cloud::documentai::v1::FetchProcessorTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::FetchProcessorTypesRequest, ::google::cloud::documentai::v1::FetchProcessorTypesResponse>* streamer) {
                       return this->StreamedFetchProcessorTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FetchProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FetchProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::FetchProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::FetchProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFetchProcessorTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::FetchProcessorTypesRequest,::google::cloud::documentai::v1::FetchProcessorTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProcessorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProcessorTypes() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::ListProcessorTypesRequest, ::google::cloud::documentai::v1::ListProcessorTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::ListProcessorTypesRequest, ::google::cloud::documentai::v1::ListProcessorTypesResponse>* streamer) {
                       return this->StreamedListProcessorTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProcessorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProcessorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorTypesRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProcessorTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::ListProcessorTypesRequest,::google::cloud::documentai::v1::ListProcessorTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProcessorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProcessorType() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::GetProcessorTypeRequest, ::google::cloud::documentai::v1::ProcessorType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::GetProcessorTypeRequest, ::google::cloud::documentai::v1::ProcessorType>* streamer) {
                       return this->StreamedGetProcessorType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProcessorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProcessorType(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorTypeRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProcessorType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::GetProcessorTypeRequest,::google::cloud::documentai::v1::ProcessorType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProcessors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProcessors() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::ListProcessorsRequest, ::google::cloud::documentai::v1::ListProcessorsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::ListProcessorsRequest, ::google::cloud::documentai::v1::ListProcessorsResponse>* streamer) {
                       return this->StreamedListProcessors(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProcessors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProcessors(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProcessors(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::ListProcessorsRequest,::google::cloud::documentai::v1::ListProcessorsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProcessor() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::GetProcessorRequest, ::google::cloud::documentai::v1::Processor>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::GetProcessorRequest, ::google::cloud::documentai::v1::Processor>* streamer) {
                       return this->StreamedGetProcessor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProcessor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::GetProcessorRequest,::google::cloud::documentai::v1::Processor>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TrainProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TrainProcessorVersion() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::TrainProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::TrainProcessorVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedTrainProcessorVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TrainProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TrainProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::TrainProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTrainProcessorVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::TrainProcessorVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProcessorVersion() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::GetProcessorVersionRequest, ::google::cloud::documentai::v1::ProcessorVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::GetProcessorVersionRequest, ::google::cloud::documentai::v1::ProcessorVersion>* streamer) {
                       return this->StreamedGetProcessorVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetProcessorVersionRequest* /*request*/, ::google::cloud::documentai::v1::ProcessorVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProcessorVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::GetProcessorVersionRequest,::google::cloud::documentai::v1::ProcessorVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProcessorVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProcessorVersions() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::ListProcessorVersionsRequest, ::google::cloud::documentai::v1::ListProcessorVersionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::ListProcessorVersionsRequest, ::google::cloud::documentai::v1::ListProcessorVersionsResponse>* streamer) {
                       return this->StreamedListProcessorVersions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProcessorVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProcessorVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListProcessorVersionsRequest* /*request*/, ::google::cloud::documentai::v1::ListProcessorVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProcessorVersions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::ListProcessorVersionsRequest,::google::cloud::documentai::v1::ListProcessorVersionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteProcessorVersion() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::DeleteProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::DeleteProcessorVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteProcessorVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteProcessorVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::DeleteProcessorVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeployProcessorVersion() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::DeployProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::DeployProcessorVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeployProcessorVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeployProcessorVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::DeployProcessorVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeployProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeployProcessorVersion() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::UndeployProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::UndeployProcessorVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeployProcessorVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeployProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeployProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::UndeployProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeployProcessorVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::UndeployProcessorVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateProcessor() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::CreateProcessorRequest, ::google::cloud::documentai::v1::Processor>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::CreateProcessorRequest, ::google::cloud::documentai::v1::Processor>* streamer) {
                       return this->StreamedCreateProcessor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::CreateProcessorRequest* /*request*/, ::google::cloud::documentai::v1::Processor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateProcessor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::CreateProcessorRequest,::google::cloud::documentai::v1::Processor>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteProcessor() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::DeleteProcessorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::DeleteProcessorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteProcessor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DeleteProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteProcessor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::DeleteProcessorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_EnableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_EnableProcessor() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::EnableProcessorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::EnableProcessorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedEnableProcessor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_EnableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status EnableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EnableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedEnableProcessor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::EnableProcessorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DisableProcessor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DisableProcessor() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::DisableProcessorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::DisableProcessorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDisableProcessor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DisableProcessor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DisableProcessor(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::DisableProcessorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDisableProcessor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::DisableProcessorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetDefaultProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetDefaultProcessorVersion() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSetDefaultProcessorVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetDefaultProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetDefaultProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetDefaultProcessorVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::SetDefaultProcessorVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReviewDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReviewDocument() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::ReviewDocumentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::ReviewDocumentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedReviewDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReviewDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReviewDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ReviewDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReviewDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::ReviewDocumentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_EvaluateProcessorVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_EvaluateProcessorVersion() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedEvaluateProcessorVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_EvaluateProcessorVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status EvaluateProcessorVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedEvaluateProcessorVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::EvaluateProcessorVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEvaluation() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::GetEvaluationRequest, ::google::cloud::documentai::v1::Evaluation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::GetEvaluationRequest, ::google::cloud::documentai::v1::Evaluation>* streamer) {
                       return this->StreamedGetEvaluation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::GetEvaluationRequest* /*request*/, ::google::cloud::documentai::v1::Evaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEvaluation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::GetEvaluationRequest,::google::cloud::documentai::v1::Evaluation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEvaluations() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::documentai::v1::ListEvaluationsRequest, ::google::cloud::documentai::v1::ListEvaluationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::documentai::v1::ListEvaluationsRequest, ::google::cloud::documentai::v1::ListEvaluationsResponse>* streamer) {
                       return this->StreamedListEvaluations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::documentai::v1::ListEvaluationsRequest* /*request*/, ::google::cloud::documentai::v1::ListEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEvaluations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::documentai::v1::ListEvaluationsRequest,::google::cloud::documentai::v1::ListEvaluationsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ProcessDocument<WithStreamedUnaryMethod_BatchProcessDocuments<WithStreamedUnaryMethod_FetchProcessorTypes<WithStreamedUnaryMethod_ListProcessorTypes<WithStreamedUnaryMethod_GetProcessorType<WithStreamedUnaryMethod_ListProcessors<WithStreamedUnaryMethod_GetProcessor<WithStreamedUnaryMethod_TrainProcessorVersion<WithStreamedUnaryMethod_GetProcessorVersion<WithStreamedUnaryMethod_ListProcessorVersions<WithStreamedUnaryMethod_DeleteProcessorVersion<WithStreamedUnaryMethod_DeployProcessorVersion<WithStreamedUnaryMethod_UndeployProcessorVersion<WithStreamedUnaryMethod_CreateProcessor<WithStreamedUnaryMethod_DeleteProcessor<WithStreamedUnaryMethod_EnableProcessor<WithStreamedUnaryMethod_DisableProcessor<WithStreamedUnaryMethod_SetDefaultProcessorVersion<WithStreamedUnaryMethod_ReviewDocument<WithStreamedUnaryMethod_EvaluateProcessorVersion<WithStreamedUnaryMethod_GetEvaluation<WithStreamedUnaryMethod_ListEvaluations<Service > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ProcessDocument<WithStreamedUnaryMethod_BatchProcessDocuments<WithStreamedUnaryMethod_FetchProcessorTypes<WithStreamedUnaryMethod_ListProcessorTypes<WithStreamedUnaryMethod_GetProcessorType<WithStreamedUnaryMethod_ListProcessors<WithStreamedUnaryMethod_GetProcessor<WithStreamedUnaryMethod_TrainProcessorVersion<WithStreamedUnaryMethod_GetProcessorVersion<WithStreamedUnaryMethod_ListProcessorVersions<WithStreamedUnaryMethod_DeleteProcessorVersion<WithStreamedUnaryMethod_DeployProcessorVersion<WithStreamedUnaryMethod_UndeployProcessorVersion<WithStreamedUnaryMethod_CreateProcessor<WithStreamedUnaryMethod_DeleteProcessor<WithStreamedUnaryMethod_EnableProcessor<WithStreamedUnaryMethod_DisableProcessor<WithStreamedUnaryMethod_SetDefaultProcessorVersion<WithStreamedUnaryMethod_ReviewDocument<WithStreamedUnaryMethod_EvaluateProcessorVersion<WithStreamedUnaryMethod_GetEvaluation<WithStreamedUnaryMethod_ListEvaluations<Service > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace documentai
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdocumentai_2fv1_2fdocument_5fprocessor_5fservice_2eproto__INCLUDED
