// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/iap/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fiap_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fiap_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/iap/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace iap {
namespace v1 {

// The Cloud Identity-Aware Proxy API.
//
// APIs for Identity-Aware Proxy Admin configurations.
class IdentityAwareProxyAdminService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.iap.v1.IdentityAwareProxyAdminService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Sets the access control policy for an Identity-Aware Proxy protected
    // resource. Replaces any existing policy.
    // More information about managing access via IAP can be found at:
    // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Gets the access control policy for an Identity-Aware Proxy protected
    // resource.
    // More information about managing access via IAP can be found at:
    // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Returns permissions that a caller has on the Identity-Aware Proxy protected
    // resource.
    // More information about managing access via IAP can be found at:
    // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    // Gets the IAP settings on a particular IAP protected resource.
    virtual ::grpc::Status GetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::google::cloud::iap::v1::IapSettings* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>> AsyncGetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>>(AsyncGetIapSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>> PrepareAsyncGetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>>(PrepareAsyncGetIapSettingsRaw(context, request, cq));
    }
    // Updates the IAP settings on a particular IAP protected resource. It
    // replaces all fields unless the `update_mask` is set.
    virtual ::grpc::Status UpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::google::cloud::iap::v1::IapSettings* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>> AsyncUpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>>(AsyncUpdateIapSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>> PrepareAsyncUpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>>(PrepareAsyncUpdateIapSettingsRaw(context, request, cq));
    }
    // Lists the existing TunnelDestGroups. To group across all locations, use a
    // `-` as the location ID. For example:
    // `/v1/projects/123/iap_tunnel/locations/-/destGroups`
    virtual ::grpc::Status ListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>> AsyncListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>>(AsyncListTunnelDestGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>> PrepareAsyncListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>>(PrepareAsyncListTunnelDestGroupsRaw(context, request, cq));
    }
    // Creates a new TunnelDestGroup.
    virtual ::grpc::Status CreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::google::cloud::iap::v1::TunnelDestGroup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>> AsyncCreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>>(AsyncCreateTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>> PrepareAsyncCreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>>(PrepareAsyncCreateTunnelDestGroupRaw(context, request, cq));
    }
    // Retrieves an existing TunnelDestGroup.
    virtual ::grpc::Status GetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::google::cloud::iap::v1::TunnelDestGroup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>> AsyncGetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>>(AsyncGetTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>> PrepareAsyncGetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>>(PrepareAsyncGetTunnelDestGroupRaw(context, request, cq));
    }
    // Deletes a TunnelDestGroup.
    virtual ::grpc::Status DeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTunnelDestGroupRaw(context, request, cq));
    }
    // Updates a TunnelDestGroup.
    virtual ::grpc::Status UpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::google::cloud::iap::v1::TunnelDestGroup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>> AsyncUpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>>(AsyncUpdateTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>> PrepareAsyncUpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>>(PrepareAsyncUpdateTunnelDestGroupRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Sets the access control policy for an Identity-Aware Proxy protected
      // resource. Replaces any existing policy.
      // More information about managing access via IAP can be found at:
      // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the access control policy for an Identity-Aware Proxy protected
      // resource.
      // More information about managing access via IAP can be found at:
      // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns permissions that a caller has on the Identity-Aware Proxy protected
      // resource.
      // More information about managing access via IAP can be found at:
      // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the IAP settings on a particular IAP protected resource.
      virtual void GetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the IAP settings on a particular IAP protected resource. It
      // replaces all fields unless the `update_mask` is set.
      virtual void UpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the existing TunnelDestGroups. To group across all locations, use a
      // `-` as the location ID. For example:
      // `/v1/projects/123/iap_tunnel/locations/-/destGroups`
      virtual void ListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new TunnelDestGroup.
      virtual void CreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves an existing TunnelDestGroup.
      virtual void GetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a TunnelDestGroup.
      virtual void DeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a TunnelDestGroup.
      virtual void UpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>* AsyncGetIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>* PrepareAsyncGetIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>* AsyncUpdateIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IapSettings>* PrepareAsyncUpdateIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* AsyncListTunnelDestGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* PrepareAsyncListTunnelDestGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>* AsyncCreateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>* PrepareAsyncCreateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>* AsyncGetTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>* PrepareAsyncGetTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>* AsyncUpdateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::TunnelDestGroup>* PrepareAsyncUpdateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    ::grpc::Status GetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::google::cloud::iap::v1::IapSettings* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>> AsyncGetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>>(AsyncGetIapSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>> PrepareAsyncGetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>>(PrepareAsyncGetIapSettingsRaw(context, request, cq));
    }
    ::grpc::Status UpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::google::cloud::iap::v1::IapSettings* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>> AsyncUpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>>(AsyncUpdateIapSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>> PrepareAsyncUpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>>(PrepareAsyncUpdateIapSettingsRaw(context, request, cq));
    }
    ::grpc::Status ListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>> AsyncListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>>(AsyncListTunnelDestGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>> PrepareAsyncListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>>(PrepareAsyncListTunnelDestGroupsRaw(context, request, cq));
    }
    ::grpc::Status CreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::google::cloud::iap::v1::TunnelDestGroup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>> AsyncCreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>>(AsyncCreateTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>> PrepareAsyncCreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>>(PrepareAsyncCreateTunnelDestGroupRaw(context, request, cq));
    }
    ::grpc::Status GetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::google::cloud::iap::v1::TunnelDestGroup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>> AsyncGetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>>(AsyncGetTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>> PrepareAsyncGetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>>(PrepareAsyncGetTunnelDestGroupRaw(context, request, cq));
    }
    ::grpc::Status DeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTunnelDestGroupRaw(context, request, cq));
    }
    ::grpc::Status UpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::google::cloud::iap::v1::TunnelDestGroup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>> AsyncUpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>>(AsyncUpdateTunnelDestGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>> PrepareAsyncUpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>>(PrepareAsyncUpdateTunnelDestGroupRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, std::function<void(::grpc::Status)>) override;
      void GetIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, std::function<void(::grpc::Status)>) override;
      void UpdateIapSettings(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTunnelDestGroups(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, std::function<void(::grpc::Status)>) override;
      void CreateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, std::function<void(::grpc::Status)>) override;
      void GetTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, std::function<void(::grpc::Status)>) override;
      void UpdateTunnelDestGroup(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>* AsyncGetIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>* PrepareAsyncGetIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>* AsyncUpdateIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IapSettings>* PrepareAsyncUpdateIapSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* AsyncListTunnelDestGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* PrepareAsyncListTunnelDestGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>* AsyncCreateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>* PrepareAsyncCreateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>* AsyncGetTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>* PrepareAsyncGetTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>* AsyncUpdateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::TunnelDestGroup>* PrepareAsyncUpdateTunnelDestGroupRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIapSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateIapSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTunnelDestGroups_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTunnelDestGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTunnelDestGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTunnelDestGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTunnelDestGroup_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Sets the access control policy for an Identity-Aware Proxy protected
    // resource. Replaces any existing policy.
    // More information about managing access via IAP can be found at:
    // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Gets the access control policy for an Identity-Aware Proxy protected
    // resource.
    // More information about managing access via IAP can be found at:
    // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Returns permissions that a caller has on the Identity-Aware Proxy protected
    // resource.
    // More information about managing access via IAP can be found at:
    // https://cloud.google.com/iap/docs/managing-access#managing_access_via_the_api
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
    // Gets the IAP settings on a particular IAP protected resource.
    virtual ::grpc::Status GetIapSettings(::grpc::ServerContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response);
    // Updates the IAP settings on a particular IAP protected resource. It
    // replaces all fields unless the `update_mask` is set.
    virtual ::grpc::Status UpdateIapSettings(::grpc::ServerContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response);
    // Lists the existing TunnelDestGroups. To group across all locations, use a
    // `-` as the location ID. For example:
    // `/v1/projects/123/iap_tunnel/locations/-/destGroups`
    virtual ::grpc::Status ListTunnelDestGroups(::grpc::ServerContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response);
    // Creates a new TunnelDestGroup.
    virtual ::grpc::Status CreateTunnelDestGroup(::grpc::ServerContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response);
    // Retrieves an existing TunnelDestGroup.
    virtual ::grpc::Status GetTunnelDestGroup(::grpc::ServerContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response);
    // Deletes a TunnelDestGroup.
    virtual ::grpc::Status DeleteTunnelDestGroup(::grpc::ServerContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* request, ::google::protobuf::Empty* response);
    // Updates a TunnelDestGroup.
    virtual ::grpc::Status UpdateTunnelDestGroup(::grpc::ServerContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIapSettings() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIapSettings(::grpc::ServerContext* context, ::google::cloud::iap::v1::GetIapSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::IapSettings>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateIapSettings() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateIapSettings(::grpc::ServerContext* context, ::google::cloud::iap::v1::UpdateIapSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::IapSettings>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTunnelDestGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTunnelDestGroups() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListTunnelDestGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTunnelDestGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* /*request*/, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTunnelDestGroups(::grpc::ServerContext* context, ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTunnelDestGroup() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTunnelDestGroup(::grpc::ServerContext* context, ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::TunnelDestGroup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTunnelDestGroup() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTunnelDestGroup(::grpc::ServerContext* context, ::google::cloud::iap::v1::GetTunnelDestGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::TunnelDestGroup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTunnelDestGroup() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DeleteTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTunnelDestGroup(::grpc::ServerContext* context, ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTunnelDestGroup() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTunnelDestGroup(::grpc::ServerContext* context, ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::TunnelDestGroup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_SetIamPolicy<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_TestIamPermissions<WithAsyncMethod_GetIapSettings<WithAsyncMethod_UpdateIapSettings<WithAsyncMethod_ListTunnelDestGroups<WithAsyncMethod_CreateTunnelDestGroup<WithAsyncMethod_GetTunnelDestGroup<WithAsyncMethod_DeleteTunnelDestGroup<WithAsyncMethod_UpdateTunnelDestGroup<Service > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIapSettings() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::GetIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response) { return this->GetIapSettings(context, request, response); }));}
    void SetMessageAllocatorFor_GetIapSettings(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::GetIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIapSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::GetIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateIapSettings() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::UpdateIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* request, ::google::cloud::iap::v1::IapSettings* response) { return this->UpdateIapSettings(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateIapSettings(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::UpdateIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::UpdateIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateIapSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTunnelDestGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTunnelDestGroups() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ListTunnelDestGroupsRequest, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* request, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* response) { return this->ListTunnelDestGroups(context, request, response); }));}
    void SetMessageAllocatorFor_ListTunnelDestGroups(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::ListTunnelDestGroupsRequest, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ListTunnelDestGroupsRequest, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTunnelDestGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTunnelDestGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* /*request*/, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTunnelDestGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* /*request*/, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTunnelDestGroup() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::CreateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response) { return this->CreateTunnelDestGroup(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTunnelDestGroup(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::CreateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::CreateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTunnelDestGroup() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response) { return this->GetTunnelDestGroup(context, request, response); }));}
    void SetMessageAllocatorFor_GetTunnelDestGroup(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::GetTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTunnelDestGroup() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTunnelDestGroup(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTunnelDestGroup(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTunnelDestGroup() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* request, ::google::cloud::iap::v1::TunnelDestGroup* response) { return this->UpdateTunnelDestGroup(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTunnelDestGroup(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_SetIamPolicy<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_TestIamPermissions<WithCallbackMethod_GetIapSettings<WithCallbackMethod_UpdateIapSettings<WithCallbackMethod_ListTunnelDestGroups<WithCallbackMethod_CreateTunnelDestGroup<WithCallbackMethod_GetTunnelDestGroup<WithCallbackMethod_DeleteTunnelDestGroup<WithCallbackMethod_UpdateTunnelDestGroup<Service > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIapSettings() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateIapSettings() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTunnelDestGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTunnelDestGroups() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListTunnelDestGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTunnelDestGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* /*request*/, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTunnelDestGroup() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTunnelDestGroup() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTunnelDestGroup() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DeleteTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTunnelDestGroup() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIapSettings() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIapSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateIapSettings() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateIapSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTunnelDestGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTunnelDestGroups() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListTunnelDestGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTunnelDestGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* /*request*/, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTunnelDestGroups(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTunnelDestGroup() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTunnelDestGroup() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTunnelDestGroup() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DeleteTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTunnelDestGroup() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIapSettings() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIapSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIapSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateIapSettings() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateIapSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateIapSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTunnelDestGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTunnelDestGroups() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTunnelDestGroups(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTunnelDestGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTunnelDestGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* /*request*/, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTunnelDestGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTunnelDestGroup() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTunnelDestGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTunnelDestGroup() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTunnelDestGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTunnelDestGroup() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTunnelDestGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTunnelDestGroup() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTunnelDestGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTunnelDestGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIapSettings() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::GetIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::GetIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>* streamer) {
                       return this->StreamedGetIapSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIapSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::GetIapSettingsRequest,::google::cloud::iap::v1::IapSettings>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateIapSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateIapSettings() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::UpdateIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::UpdateIapSettingsRequest, ::google::cloud::iap::v1::IapSettings>* streamer) {
                       return this->StreamedUpdateIapSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateIapSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateIapSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateIapSettingsRequest* /*request*/, ::google::cloud::iap::v1::IapSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateIapSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::UpdateIapSettingsRequest,::google::cloud::iap::v1::IapSettings>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTunnelDestGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTunnelDestGroups() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::ListTunnelDestGroupsRequest, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::ListTunnelDestGroupsRequest, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* streamer) {
                       return this->StreamedListTunnelDestGroups(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTunnelDestGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTunnelDestGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListTunnelDestGroupsRequest* /*request*/, ::google::cloud::iap::v1::ListTunnelDestGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTunnelDestGroups(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::ListTunnelDestGroupsRequest,::google::cloud::iap::v1::ListTunnelDestGroupsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTunnelDestGroup() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::CreateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::CreateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>* streamer) {
                       return this->StreamedCreateTunnelDestGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::CreateTunnelDestGroupRequest,::google::cloud::iap::v1::TunnelDestGroup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTunnelDestGroup() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::GetTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::GetTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>* streamer) {
                       return this->StreamedGetTunnelDestGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::GetTunnelDestGroupRequest,::google::cloud::iap::v1::TunnelDestGroup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTunnelDestGroup() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTunnelDestGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::DeleteTunnelDestGroupRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTunnelDestGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTunnelDestGroup() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest, ::google::cloud::iap::v1::TunnelDestGroup>* streamer) {
                       return this->StreamedUpdateTunnelDestGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTunnelDestGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTunnelDestGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest* /*request*/, ::google::cloud::iap::v1::TunnelDestGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTunnelDestGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::UpdateTunnelDestGroupRequest,::google::cloud::iap::v1::TunnelDestGroup>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_GetIapSettings<WithStreamedUnaryMethod_UpdateIapSettings<WithStreamedUnaryMethod_ListTunnelDestGroups<WithStreamedUnaryMethod_CreateTunnelDestGroup<WithStreamedUnaryMethod_GetTunnelDestGroup<WithStreamedUnaryMethod_DeleteTunnelDestGroup<WithStreamedUnaryMethod_UpdateTunnelDestGroup<Service > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_GetIapSettings<WithStreamedUnaryMethod_UpdateIapSettings<WithStreamedUnaryMethod_ListTunnelDestGroups<WithStreamedUnaryMethod_CreateTunnelDestGroup<WithStreamedUnaryMethod_GetTunnelDestGroup<WithStreamedUnaryMethod_DeleteTunnelDestGroup<WithStreamedUnaryMethod_UpdateTunnelDestGroup<Service > > > > > > > > > > StreamedService;
};

// API to programmatically create, list and retrieve Identity Aware Proxy (IAP)
// OAuth brands; and create, retrieve, delete and reset-secret of IAP OAuth
// clients.
class IdentityAwareProxyOAuthService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.iap.v1.IdentityAwareProxyOAuthService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the existing brands for the project.
    virtual ::grpc::Status ListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::google::cloud::iap::v1::ListBrandsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListBrandsResponse>> AsyncListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListBrandsResponse>>(AsyncListBrandsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListBrandsResponse>> PrepareAsyncListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListBrandsResponse>>(PrepareAsyncListBrandsRaw(context, request, cq));
    }
    // Constructs a new OAuth brand for the project if one does not exist.
    // The created brand is "internal only", meaning that OAuth clients created
    // under it only accept requests from users who belong to the same Google
    // Workspace organization as the project. The brand is created in an
    // un-reviewed status. NOTE: The "internal only" status can be manually
    // changed in the Google Cloud Console. Requires that a brand does not already
    // exist for the project, and that the specified support email is owned by the
    // caller.
    virtual ::grpc::Status CreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::google::cloud::iap::v1::Brand* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>> AsyncCreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>>(AsyncCreateBrandRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>> PrepareAsyncCreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>>(PrepareAsyncCreateBrandRaw(context, request, cq));
    }
    // Retrieves the OAuth brand of the project.
    virtual ::grpc::Status GetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::google::cloud::iap::v1::Brand* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>> AsyncGetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>>(AsyncGetBrandRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>> PrepareAsyncGetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>>(PrepareAsyncGetBrandRaw(context, request, cq));
    }
    // Creates an Identity Aware Proxy (IAP) OAuth client. The client is owned
    // by IAP. Requires that the brand for the project exists and that it is
    // set for internal-only use.
    virtual ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>> AsyncCreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(AsyncCreateIdentityAwareProxyClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>> PrepareAsyncCreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(PrepareAsyncCreateIdentityAwareProxyClientRaw(context, request, cq));
    }
    // Lists the existing clients for the brand.
    virtual ::grpc::Status ListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>> AsyncListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>>(AsyncListIdentityAwareProxyClientsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>> PrepareAsyncListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>>(PrepareAsyncListIdentityAwareProxyClientsRaw(context, request, cq));
    }
    // Retrieves an Identity Aware Proxy (IAP) OAuth client.
    // Requires that the client is owned by IAP.
    virtual ::grpc::Status GetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>> AsyncGetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(AsyncGetIdentityAwareProxyClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>> PrepareAsyncGetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(PrepareAsyncGetIdentityAwareProxyClientRaw(context, request, cq));
    }
    // Resets an Identity Aware Proxy (IAP) OAuth client secret. Useful if the
    // secret was compromised. Requires that the client is owned by IAP.
    virtual ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>> AsyncResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(AsyncResetIdentityAwareProxyClientSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>> PrepareAsyncResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(PrepareAsyncResetIdentityAwareProxyClientSecretRaw(context, request, cq));
    }
    // Deletes an Identity Aware Proxy (IAP) OAuth client. Useful for removing
    // obsolete clients, managing the number of clients in a given project, and
    // cleaning up after tests. Requires that the client is owned by IAP.
    virtual ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteIdentityAwareProxyClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteIdentityAwareProxyClientRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the existing brands for the project.
      virtual void ListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest* request, ::google::cloud::iap::v1::ListBrandsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest* request, ::google::cloud::iap::v1::ListBrandsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Constructs a new OAuth brand for the project if one does not exist.
      // The created brand is "internal only", meaning that OAuth clients created
      // under it only accept requests from users who belong to the same Google
      // Workspace organization as the project. The brand is created in an
      // un-reviewed status. NOTE: The "internal only" status can be manually
      // changed in the Google Cloud Console. Requires that a brand does not already
      // exist for the project, and that the specified support email is owned by the
      // caller.
      virtual void CreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest* request, ::google::cloud::iap::v1::Brand* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest* request, ::google::cloud::iap::v1::Brand* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the OAuth brand of the project.
      virtual void GetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest* request, ::google::cloud::iap::v1::Brand* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest* request, ::google::cloud::iap::v1::Brand* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an Identity Aware Proxy (IAP) OAuth client. The client is owned
      // by IAP. Requires that the brand for the project exists and that it is
      // set for internal-only use.
      virtual void CreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the existing clients for the brand.
      virtual void ListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves an Identity Aware Proxy (IAP) OAuth client.
      // Requires that the client is owned by IAP.
      virtual void GetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets an Identity Aware Proxy (IAP) OAuth client secret. Useful if the
      // secret was compromised. Requires that the client is owned by IAP.
      virtual void ResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an Identity Aware Proxy (IAP) OAuth client. Useful for removing
      // obsolete clients, managing the number of clients in a given project, and
      // cleaning up after tests. Requires that the client is owned by IAP.
      virtual void DeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListBrandsResponse>* AsyncListBrandsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListBrandsResponse>* PrepareAsyncListBrandsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>* AsyncCreateBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>* PrepareAsyncCreateBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>* AsyncGetBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::Brand>* PrepareAsyncGetBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>* AsyncCreateIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>* PrepareAsyncCreateIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* AsyncListIdentityAwareProxyClientsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* PrepareAsyncListIdentityAwareProxyClientsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>* AsyncGetIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>* PrepareAsyncGetIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>* AsyncResetIdentityAwareProxyClientSecretRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::iap::v1::IdentityAwareProxyClient>* PrepareAsyncResetIdentityAwareProxyClientSecretRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::google::cloud::iap::v1::ListBrandsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListBrandsResponse>> AsyncListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListBrandsResponse>>(AsyncListBrandsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListBrandsResponse>> PrepareAsyncListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListBrandsResponse>>(PrepareAsyncListBrandsRaw(context, request, cq));
    }
    ::grpc::Status CreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::google::cloud::iap::v1::Brand* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>> AsyncCreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>>(AsyncCreateBrandRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>> PrepareAsyncCreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>>(PrepareAsyncCreateBrandRaw(context, request, cq));
    }
    ::grpc::Status GetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::google::cloud::iap::v1::Brand* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>> AsyncGetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>>(AsyncGetBrandRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>> PrepareAsyncGetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>>(PrepareAsyncGetBrandRaw(context, request, cq));
    }
    ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>> AsyncCreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(AsyncCreateIdentityAwareProxyClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>> PrepareAsyncCreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(PrepareAsyncCreateIdentityAwareProxyClientRaw(context, request, cq));
    }
    ::grpc::Status ListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>> AsyncListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>>(AsyncListIdentityAwareProxyClientsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>> PrepareAsyncListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>>(PrepareAsyncListIdentityAwareProxyClientsRaw(context, request, cq));
    }
    ::grpc::Status GetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>> AsyncGetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(AsyncGetIdentityAwareProxyClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>> PrepareAsyncGetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(PrepareAsyncGetIdentityAwareProxyClientRaw(context, request, cq));
    }
    ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>> AsyncResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(AsyncResetIdentityAwareProxyClientSecretRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>> PrepareAsyncResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>>(PrepareAsyncResetIdentityAwareProxyClientSecretRaw(context, request, cq));
    }
    ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteIdentityAwareProxyClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteIdentityAwareProxyClientRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest* request, ::google::cloud::iap::v1::ListBrandsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBrands(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest* request, ::google::cloud::iap::v1::ListBrandsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest* request, ::google::cloud::iap::v1::Brand* response, std::function<void(::grpc::Status)>) override;
      void CreateBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest* request, ::google::cloud::iap::v1::Brand* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest* request, ::google::cloud::iap::v1::Brand* response, std::function<void(::grpc::Status)>) override;
      void GetBrand(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest* request, ::google::cloud::iap::v1::Brand* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, std::function<void(::grpc::Status)>) override;
      void CreateIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListIdentityAwareProxyClients(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, std::function<void(::grpc::Status)>) override;
      void GetIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, std::function<void(::grpc::Status)>) override;
      void ResetIdentityAwareProxyClientSecret(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteIdentityAwareProxyClient(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListBrandsResponse>* AsyncListBrandsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListBrandsResponse>* PrepareAsyncListBrandsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListBrandsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>* AsyncCreateBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>* PrepareAsyncCreateBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateBrandRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>* AsyncGetBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::Brand>* PrepareAsyncGetBrandRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetBrandRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>* AsyncCreateIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>* PrepareAsyncCreateIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* AsyncListIdentityAwareProxyClientsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* PrepareAsyncListIdentityAwareProxyClientsRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>* AsyncGetIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>* PrepareAsyncGetIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>* AsyncResetIdentityAwareProxyClientSecretRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::iap::v1::IdentityAwareProxyClient>* PrepareAsyncResetIdentityAwareProxyClientSecretRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteIdentityAwareProxyClientRaw(::grpc::ClientContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListBrands_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBrand_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBrand_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateIdentityAwareProxyClient_;
    const ::grpc::internal::RpcMethod rpcmethod_ListIdentityAwareProxyClients_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIdentityAwareProxyClient_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetIdentityAwareProxyClientSecret_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteIdentityAwareProxyClient_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the existing brands for the project.
    virtual ::grpc::Status ListBrands(::grpc::ServerContext* context, const ::google::cloud::iap::v1::ListBrandsRequest* request, ::google::cloud::iap::v1::ListBrandsResponse* response);
    // Constructs a new OAuth brand for the project if one does not exist.
    // The created brand is "internal only", meaning that OAuth clients created
    // under it only accept requests from users who belong to the same Google
    // Workspace organization as the project. The brand is created in an
    // un-reviewed status. NOTE: The "internal only" status can be manually
    // changed in the Google Cloud Console. Requires that a brand does not already
    // exist for the project, and that the specified support email is owned by the
    // caller.
    virtual ::grpc::Status CreateBrand(::grpc::ServerContext* context, const ::google::cloud::iap::v1::CreateBrandRequest* request, ::google::cloud::iap::v1::Brand* response);
    // Retrieves the OAuth brand of the project.
    virtual ::grpc::Status GetBrand(::grpc::ServerContext* context, const ::google::cloud::iap::v1::GetBrandRequest* request, ::google::cloud::iap::v1::Brand* response);
    // Creates an Identity Aware Proxy (IAP) OAuth client. The client is owned
    // by IAP. Requires that the brand for the project exists and that it is
    // set for internal-only use.
    virtual ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ServerContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response);
    // Lists the existing clients for the brand.
    virtual ::grpc::Status ListIdentityAwareProxyClients(::grpc::ServerContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response);
    // Retrieves an Identity Aware Proxy (IAP) OAuth client.
    // Requires that the client is owned by IAP.
    virtual ::grpc::Status GetIdentityAwareProxyClient(::grpc::ServerContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response);
    // Resets an Identity Aware Proxy (IAP) OAuth client secret. Useful if the
    // secret was compromised. Requires that the client is owned by IAP.
    virtual ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ServerContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response);
    // Deletes an Identity Aware Proxy (IAP) OAuth client. Useful for removing
    // obsolete clients, managing the number of clients in a given project, and
    // cleaning up after tests. Requires that the client is owned by IAP.
    virtual ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ServerContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBrands : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBrands() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListBrands() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBrands(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListBrandsRequest* /*request*/, ::google::cloud::iap::v1::ListBrandsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBrands(::grpc::ServerContext* context, ::google::cloud::iap::v1::ListBrandsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::ListBrandsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBrand() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBrand(::grpc::ServerContext* context, ::google::cloud::iap::v1::CreateBrandRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::Brand>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBrand() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBrand(::grpc::ServerContext* context, ::google::cloud::iap::v1::GetBrandRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::Brand>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateIdentityAwareProxyClient(::grpc::ServerContext* context, ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::IdentityAwareProxyClient>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListIdentityAwareProxyClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListIdentityAwareProxyClients() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListIdentityAwareProxyClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIdentityAwareProxyClients(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* /*request*/, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListIdentityAwareProxyClients(::grpc::ServerContext* context, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIdentityAwareProxyClient(::grpc::ServerContext* context, ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::IdentityAwareProxyClient>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetIdentityAwareProxyClientSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetIdentityAwareProxyClientSecret() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ResetIdentityAwareProxyClientSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetIdentityAwareProxyClientSecret(::grpc::ServerContext* context, ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::iap::v1::IdentityAwareProxyClient>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteIdentityAwareProxyClient(::grpc::ServerContext* context, ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListBrands<WithAsyncMethod_CreateBrand<WithAsyncMethod_GetBrand<WithAsyncMethod_CreateIdentityAwareProxyClient<WithAsyncMethod_ListIdentityAwareProxyClients<WithAsyncMethod_GetIdentityAwareProxyClient<WithAsyncMethod_ResetIdentityAwareProxyClientSecret<WithAsyncMethod_DeleteIdentityAwareProxyClient<Service > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListBrands : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBrands() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ListBrandsRequest, ::google::cloud::iap::v1::ListBrandsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::ListBrandsRequest* request, ::google::cloud::iap::v1::ListBrandsResponse* response) { return this->ListBrands(context, request, response); }));}
    void SetMessageAllocatorFor_ListBrands(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::ListBrandsRequest, ::google::cloud::iap::v1::ListBrandsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ListBrandsRequest, ::google::cloud::iap::v1::ListBrandsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBrands() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBrands(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListBrandsRequest* /*request*/, ::google::cloud::iap::v1::ListBrandsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBrands(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::ListBrandsRequest* /*request*/, ::google::cloud::iap::v1::ListBrandsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBrand() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::CreateBrandRequest, ::google::cloud::iap::v1::Brand>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::CreateBrandRequest* request, ::google::cloud::iap::v1::Brand* response) { return this->CreateBrand(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBrand(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::CreateBrandRequest, ::google::cloud::iap::v1::Brand>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::CreateBrandRequest, ::google::cloud::iap::v1::Brand>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBrand(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::CreateBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBrand() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetBrandRequest, ::google::cloud::iap::v1::Brand>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::GetBrandRequest* request, ::google::cloud::iap::v1::Brand* response) { return this->GetBrand(context, request, response); }));}
    void SetMessageAllocatorFor_GetBrand(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::GetBrandRequest, ::google::cloud::iap::v1::Brand>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetBrandRequest, ::google::cloud::iap::v1::Brand>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBrand(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::GetBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) { return this->CreateIdentityAwareProxyClient(context, request, response); }));}
    void SetMessageAllocatorFor_CreateIdentityAwareProxyClient(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateIdentityAwareProxyClient(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListIdentityAwareProxyClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListIdentityAwareProxyClients() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* request, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* response) { return this->ListIdentityAwareProxyClients(context, request, response); }));}
    void SetMessageAllocatorFor_ListIdentityAwareProxyClients(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListIdentityAwareProxyClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIdentityAwareProxyClients(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* /*request*/, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListIdentityAwareProxyClients(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* /*request*/, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) { return this->GetIdentityAwareProxyClient(context, request, response); }));}
    void SetMessageAllocatorFor_GetIdentityAwareProxyClient(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIdentityAwareProxyClient(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetIdentityAwareProxyClientSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetIdentityAwareProxyClientSecret() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* request, ::google::cloud::iap::v1::IdentityAwareProxyClient* response) { return this->ResetIdentityAwareProxyClientSecret(context, request, response); }));}
    void SetMessageAllocatorFor_ResetIdentityAwareProxyClientSecret(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetIdentityAwareProxyClientSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetIdentityAwareProxyClientSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* request, ::google::protobuf::Empty* response) { return this->DeleteIdentityAwareProxyClient(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteIdentityAwareProxyClient(
        ::grpc::MessageAllocator< ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteIdentityAwareProxyClient(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListBrands<WithCallbackMethod_CreateBrand<WithCallbackMethod_GetBrand<WithCallbackMethod_CreateIdentityAwareProxyClient<WithCallbackMethod_ListIdentityAwareProxyClients<WithCallbackMethod_GetIdentityAwareProxyClient<WithCallbackMethod_ResetIdentityAwareProxyClientSecret<WithCallbackMethod_DeleteIdentityAwareProxyClient<Service > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListBrands : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBrands() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListBrands() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBrands(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListBrandsRequest* /*request*/, ::google::cloud::iap::v1::ListBrandsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBrand() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBrand() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListIdentityAwareProxyClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListIdentityAwareProxyClients() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListIdentityAwareProxyClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIdentityAwareProxyClients(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* /*request*/, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetIdentityAwareProxyClientSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetIdentityAwareProxyClientSecret() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ResetIdentityAwareProxyClientSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBrands : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBrands() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListBrands() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBrands(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListBrandsRequest* /*request*/, ::google::cloud::iap::v1::ListBrandsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBrands(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBrand() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBrand(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBrand() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBrand(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateIdentityAwareProxyClient(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListIdentityAwareProxyClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListIdentityAwareProxyClients() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListIdentityAwareProxyClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIdentityAwareProxyClients(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* /*request*/, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListIdentityAwareProxyClients(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIdentityAwareProxyClient(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetIdentityAwareProxyClientSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetIdentityAwareProxyClientSecret() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ResetIdentityAwareProxyClientSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetIdentityAwareProxyClientSecret(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteIdentityAwareProxyClient(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBrands : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBrands() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBrands(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBrands() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBrands(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListBrandsRequest* /*request*/, ::google::cloud::iap::v1::ListBrandsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBrands(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBrand() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBrand(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBrand(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBrand() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBrand(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBrand(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateIdentityAwareProxyClient(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateIdentityAwareProxyClient(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListIdentityAwareProxyClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListIdentityAwareProxyClients() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListIdentityAwareProxyClients(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListIdentityAwareProxyClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIdentityAwareProxyClients(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* /*request*/, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListIdentityAwareProxyClients(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIdentityAwareProxyClient(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIdentityAwareProxyClient(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetIdentityAwareProxyClientSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetIdentityAwareProxyClientSecret() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetIdentityAwareProxyClientSecret(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetIdentityAwareProxyClientSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetIdentityAwareProxyClientSecret(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteIdentityAwareProxyClient(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteIdentityAwareProxyClient(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBrands : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBrands() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::ListBrandsRequest, ::google::cloud::iap::v1::ListBrandsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::ListBrandsRequest, ::google::cloud::iap::v1::ListBrandsResponse>* streamer) {
                       return this->StreamedListBrands(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBrands() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBrands(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListBrandsRequest* /*request*/, ::google::cloud::iap::v1::ListBrandsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBrands(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::ListBrandsRequest,::google::cloud::iap::v1::ListBrandsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBrand() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::CreateBrandRequest, ::google::cloud::iap::v1::Brand>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::CreateBrandRequest, ::google::cloud::iap::v1::Brand>* streamer) {
                       return this->StreamedCreateBrand(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBrand(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::CreateBrandRequest,::google::cloud::iap::v1::Brand>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBrand : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBrand() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::GetBrandRequest, ::google::cloud::iap::v1::Brand>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::GetBrandRequest, ::google::cloud::iap::v1::Brand>* streamer) {
                       return this->StreamedGetBrand(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBrand() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBrand(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetBrandRequest* /*request*/, ::google::cloud::iap::v1::Brand* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBrand(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::GetBrandRequest,::google::cloud::iap::v1::Brand>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>* streamer) {
                       return this->StreamedCreateIdentityAwareProxyClient(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateIdentityAwareProxyClient(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::CreateIdentityAwareProxyClientRequest,::google::cloud::iap::v1::IdentityAwareProxyClient>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListIdentityAwareProxyClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListIdentityAwareProxyClients() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* streamer) {
                       return this->StreamedListIdentityAwareProxyClients(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListIdentityAwareProxyClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListIdentityAwareProxyClients(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest* /*request*/, ::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListIdentityAwareProxyClients(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::ListIdentityAwareProxyClientsRequest,::google::cloud::iap::v1::ListIdentityAwareProxyClientsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>* streamer) {
                       return this->StreamedGetIdentityAwareProxyClient(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIdentityAwareProxyClient(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::GetIdentityAwareProxyClientRequest,::google::cloud::iap::v1::IdentityAwareProxyClient>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetIdentityAwareProxyClientSecret : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetIdentityAwareProxyClientSecret() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest, ::google::cloud::iap::v1::IdentityAwareProxyClient>* streamer) {
                       return this->StreamedResetIdentityAwareProxyClientSecret(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetIdentityAwareProxyClientSecret() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetIdentityAwareProxyClientSecret(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest* /*request*/, ::google::cloud::iap::v1::IdentityAwareProxyClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetIdentityAwareProxyClientSecret(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::ResetIdentityAwareProxyClientSecretRequest,::google::cloud::iap::v1::IdentityAwareProxyClient>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteIdentityAwareProxyClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteIdentityAwareProxyClient() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteIdentityAwareProxyClient(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteIdentityAwareProxyClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteIdentityAwareProxyClient(::grpc::ServerContext* /*context*/, const ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteIdentityAwareProxyClient(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::iap::v1::DeleteIdentityAwareProxyClientRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListBrands<WithStreamedUnaryMethod_CreateBrand<WithStreamedUnaryMethod_GetBrand<WithStreamedUnaryMethod_CreateIdentityAwareProxyClient<WithStreamedUnaryMethod_ListIdentityAwareProxyClients<WithStreamedUnaryMethod_GetIdentityAwareProxyClient<WithStreamedUnaryMethod_ResetIdentityAwareProxyClientSecret<WithStreamedUnaryMethod_DeleteIdentityAwareProxyClient<Service > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListBrands<WithStreamedUnaryMethod_CreateBrand<WithStreamedUnaryMethod_GetBrand<WithStreamedUnaryMethod_CreateIdentityAwareProxyClient<WithStreamedUnaryMethod_ListIdentityAwareProxyClients<WithStreamedUnaryMethod_GetIdentityAwareProxyClient<WithStreamedUnaryMethod_ResetIdentityAwareProxyClientSecret<WithStreamedUnaryMethod_DeleteIdentityAwareProxyClient<Service > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace iap
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fiap_2fv1_2fservice_2eproto__INCLUDED
